-- MySQL Workbench Synchronization
-- Generated: 2019-12-04 12:01
-- Model: nccs
-- Version: D06.07.02
-- Project: idste-server
-- Author: marh(marh@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

ALTER TABLE `nccs`.`SectionTable`
CHANGE COLUMN `name` `name` VARCHAR(32) NOT NULL DEFAULT '0' COMMENT '仅填写数字，表示第几节课。为保证兼容，未做类型变更' ,
CHANGE COLUMN `start` `start` TIME NOT NULL DEFAULT '00:00:00' ,
CHANGE COLUMN `end` `end` TIME NOT NULL DEFAULT '23:59:59' ,
ADD COLUMN `alias` VARCHAR(32) NOT NULL COMMENT '节次别名，如第一节' AFTER `name`,
ADD PRIMARY KEY (`name`),
ADD UNIQUE INDEX `SectionTableUnique` (`zone` ASC, `name` ASC),
ADD INDEX `SectionTableIndex` (`name` ASC, `zone` ASC);

CREATE TABLE IF NOT EXISTS `nccs`.`TimetableV1` (
  `ID` INT(11) NOT NULL AUTO_INCREMENT,
  `Dev_Name` VARCHAR(50) NOT NULL,
  `User_Sn` VARCHAR(20) NOT NULL,
  `Zone` VARCHAR(32) NOT NULL DEFAULT '',
  `CourseName` VARCHAR(64) NOT NULL DEFAULT '',
  `TermName` VARCHAR(32) NOT NULL DEFAULT '',
  `SectionStart` INT(11) NOT NULL DEFAULT '0',
  `SectionEnd` INT(11) NOT NULL DEFAULT '0',
  `WeekStart` INT(11) NOT NULL DEFAULT '1',
  `WeekEnd` INT(11) NOT NULL DEFAULT '9999',
  `WeekDay` INT(11) NOT NULL DEFAULT '6',
  `WeekType` ENUM('single', 'double', 'all') NOT NULL DEFAULT 'all',
  `Active` ENUM('yes', 'no') NOT NULL DEFAULT 'yes' COMMENT '是否活动，活动状态的课表会用于设备控制',
  PRIMARY KEY (`ID`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`Scene` (
  `id` INT NOT NULL,
  `name` VARCHAR(45) NOT NULL DEFAULT '' COMMENT '名称',
  `icon` VARCHAR(45) NOT NULL DEFAULT '' COMMENT '图标',
  `control_list` VARCHAR(2048) NOT NULL DEFAULT '{}' COMMENT '操作清单',
  `product_match_preg` VARCHAR(128) NOT NULL DEFAULT '' COMMENT '产品匹配列表',
  PRIMARY KEY (`id`))
COMMENT = '设备场景表';

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
