-- MySQL Workbench Synchronization
-- Generated: 2021-3-1 09:39
-- Model: New Model
-- Version: D07.01.06
-- Project: nccs`
-- Author: ww

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

ALTER TABLE `nccs`.`SystemLog` 
ADD COLUMN `SchoolID` INT(11) NOT NULL DEFAULT '0' after `id`;

ALTER TABLE `nccs`.`SystemLog` 
ADD INDEX `schoolIndex` USING BTREE (`SchoolID` ASC);

ALTER TABLE `nccs`.`DeviceLog` 
ADD COLUMN `SchoolID` INT(11) NOT NULL DEFAULT '0' after `DevLogID`;

ALTER TABLE `nccs`.`DeviceLog` 
ADD INDEX `schoolIndex` USING BTREE (`SchoolID` ASC);

ALTER TABLE `nccs`.`DeviceStatistic` 
ADD COLUMN `SchoolID` INT(11) NOT NULL DEFAULT '0';

ALTER TABLE `nccs`.`DeviceStatistic` 
DROP PRIMARY Key;

ALTER TABLE `nccs`.`DeviceStatistic` 
ADD PRIMARY Key (`DeviceID`,`StatisticDay`,`SchoolID`);

ALTER TABLE `nccs`.`DeviceStatistic` 
ADD INDEX `schoolIndex` USING BTREE (`SchoolID` ASC);

ALTER TABLE `nccs`.`Scene` 
ADD COLUMN `SchoolID` INT(11) NOT NULL DEFAULT '0' after `id`;

ALTER TABLE `nccs`.`Scene` 
ADD INDEX `schoolIndex` USING BTREE (`SchoolID` ASC);


ALTER TABLE `nccs`.`SchoolInfo` 
ADD COLUMN `disable` smallint(2) NOT NULL DEFAULT '0' after owner;

ALTER TABLE `nccs`.`SchoolInfo` 
ADD COLUMN `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP after update_time;

CREATE TABLE IF NOT EXISTS `nccs`.`DeviceAuthSupplyLog` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Type` varchar(255) NOT NULL DEFAULT '' COMMENT '认证类型',
  `Supply` varchar(255) NOT NULL DEFAULT '' COMMENT '供应商',
  `Url` varchar(1024) NOT NULL DEFAULT '' COMMENT '请求URL',
  `ReqInfo` varchar(4096) NOT NULL DEFAULT '' COMMENT '请求数据',
  `ResInfo` varchar(4096) NOT NULL DEFAULT '' COMMENT '响应数据',
  `Result` tinyint(4) NOT NULL DEFAULT '0' COMMENT '请求结果 0-失败 1-成功',
  `ErrorType` tinyint(4) NOT NULL DEFAULT '0' COMMENT '错误类型 0-无错误 1-系统未配置好 2-供应商返回错误 3-人员信息未找到 4-网络出现问题',
  `Error` varchar(4096) NOT NULL DEFAULT '' COMMENT '错误信息',
  `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `UseTime` int(11) NOT NULL DEFAULT '0' COMMENT '耗时（毫秒数）',
  `Sync` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否同步 0-未同步 1-已同步',
  `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='设备认证供应商日志';

INSERT INTO BaseInfo(InfomationID, Description, InfoValue, SchoolID) VALUES ('624', '{"supply":"iDste", "url":"http://127.0.0.1:20086", "app_id":"123213213", "key":"E213D9411B41F3C7"}', 0, 0) on duplicate key update InfomationID=values(InfomationID);

CREATE TABLE IF NOT EXISTS `nccs`.`DeviceScenes`  (
  `DeviceSceneID` int(11) NOT NULL AUTO_INCREMENT,
  `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
  `SceneID` int(11) NOT NULL,
  `SceneName` varchar(96) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '场景名称不能超过32个汉字',
  `SceneCtrlList` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '场景控制列表，为json字符串',
  PRIMARY KEY (`DeviceSceneID`) USING BTREE,
  UNIQUE INDEX `device_scene`(`DeviceID`, `SceneID`) USING BTREE COMMENT '一个设备不能有两个相同id的场景'
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
