-- MySQL Workbench Synchronization
-- Generated: 2021-5-12 18:13
-- Model: New Model
-- Version: D07.01.08
-- Project: nccs`
-- Author: ww
SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

ALTER TABLE `nccs`.`DeviceList`
ADD COLUMN `DoubleClass` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否支持双师课堂 0-不支持 1-支持' after `SchoolID`;

CREATE TABLE `DoubleClass` (
  `ClassId` int(11) NOT NULL AUTO_INCREMENT COMMENT '课堂ID',
  `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '课堂名称',
  `ExecTime` enum('WeekLoop','FixedTime') NOT NULL DEFAULT 'FixedTime' COMMENT 'WeekLoop - 按周循环  FixedTime - 固定时间',
  `FixStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 开始时间',
  `FixEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 结束时间',
  `WeekStime` time NOT NULL COMMENT '按周循环 - 开始时间',
  `WeekEtime` time NOT NULL COMMENT '按周循环 - 结束时间',
  `WeekDays` varchar(255) NOT NULL DEFAULT '' COMMENT '0-6 对应 星期一 到 星期天 (英文逗号分隔,结束都加英文逗号)',
  `Valid` tinyint(4) NOT NULL DEFAULT '1' COMMENT '是否有效 1-有效 0-无效',
  `ConfigMd5` varchar(255) NOT NULL DEFAULT '' COMMENT '配置MD5',
  `SchoolId` int(11) NOT NULL DEFAULT '0' COMMENT '学校ID',
  `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
  `ModTIme` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `NextStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '下次开始时间',
  `NextEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '下次结束时间',
  `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
  `CourseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '上课时间',
  `CourseStatus` enum('free','active','stop','fault') NOT NULL DEFAULT 'free' COMMENT '上课状态（无课-free  上课-active  停止-stop  故障-fault）',
  `CourseFault` varchar(1024) NOT NULL DEFAULT '' COMMENT '课程故障原因',
  PRIMARY KEY (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂列表';

CREATE TABLE `DoubleClassDevice` (
  `Id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
  `DevId` varchar(50) NOT NULL DEFAULT '' COMMENT '设备ID',
  `ClassType` enum('lead','follow') NOT NULL DEFAULT 'lead' COMMENT '教室类型（lead - 主讲教室  follow - 辅讲教室）',
  `DeviceType` enum('main','slave') NOT NULL DEFAULT 'main' COMMENT '设备类型（main - 主控设备  slave - 从设备）',
  `Ip` varchar(255) NOT NULL DEFAULT '' COMMENT '设备IP地址',
  `CmdConfig` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0-未发送配置命令 1-已发送配置命令',
  `CmdConfigTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送配置命令时间',
  PRIMARY KEY (`Id`),
  UNIQUE KEY `ClassDev` (`ClassId`,`DevId`),
  KEY `ClassId` (`ClassId`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂设备';

CREATE TABLE `DoubleClassCourse` (
  `CourseId` int(11) NOT NULL AUTO_INCREMENT COMMENT '课程ID',
  `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
  `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '课堂名称',
  `ExecTime` enum('WeekLoop','FixedTime') NOT NULL DEFAULT 'FixedTime' COMMENT '执行时间',
  `FixStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间-开始时间',
  `FixEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '固定时间 - 结束时间',
  `WeekStime` time NOT NULL COMMENT '按周循环-开始时间',
  `WeekEtime` time NOT NULL COMMENT '按周循环-结束时间',
  `WeekDays` varchar(255) NOT NULL DEFAULT '' COMMENT '0-6 对应 星期一 到 星期天 (英文逗号分隔,结束加英文逗号)',
  `CourseStime` bigint(20) NOT NULL DEFAULT '0' COMMENT '课程开始时间',
  `CourseEtime` bigint(20) NOT NULL DEFAULT '0' COMMENT '课程结束时间',
  `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
  `CmdStartNums` int(11) NOT NULL DEFAULT '0' COMMENT '开始命令发送次数',
  `CmdStartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始命令发送时间',
  `CourseStarted` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报已启动 0-未启动 1-已启动',
  `CmdEndNums` int(11) NOT NULL DEFAULT '0' COMMENT '结束命令发送次数',
  `CmdEndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束命令发送时间',
  `CourseEnded` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报已结束 0-未上报 1-已上报',
  `CourseStatus` enum('creat','active','stop','fault','end') NOT NULL DEFAULT 'creat' COMMENT '课程状态（生成-creat  上课-active  停止-stop  故障-fault 结束-end）',
  `CourseFault` varchar(1024) NOT NULL DEFAULT '' COMMENT '故障原因',
  `ModTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后修改时间',
  PRIMARY KEY (`CourseId`),
  KEY `ClassId` (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂课程（定时生成）';

CREATE TABLE `DoubleClassCourseDevice` (
  `Id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
  `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
  `DevId` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
  `ClassType` enum('lead','follow') NOT NULL DEFAULT 'lead' COMMENT '教室类型（lead - 主讲教室  follow - 辅讲教室）',
  `DeviceType` enum('main','slave') NOT NULL DEFAULT 'main' COMMENT '设备类型（main - 主控设备  slave - 从设备）',
  `CmdStart` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否发送启动命令 0-未发送 1-已发送',
  `CmdStartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送启动命令时间',
  `CmdStartNums` int(11) NOT NULL DEFAULT '0' COMMENT '发送启动命令次数',
  `CmdStartReport` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报处于双师课堂 0-未处于 1-已处于',
  `CmdStartReportTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '设备上报处于双师课堂时间',
  `CmdEnd` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否发送停止命令 0-未发送 1-已发送',
  `CmdEndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '发送停止命令时间',
  `CmdEndNums` int(11) NOT NULL DEFAULT '0' COMMENT '发送停止命令次数',
  `CmdEndReport` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否上报不处于双师课堂 0-未上报 1-已上报',
  `CmdEndReportTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '设备上报不处于双师课堂时间',
  PRIMARY KEY (`Id`),
  UNIQUE KEY `CourseDev` (`CourseId`,`DevId`),
  KEY `ClassId` (`ClassId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂课程设备';

CREATE TABLE `nccs`.`DoubleClassLog` (
  `Id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ClassId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂ID',
  `CourseId` int(11) NOT NULL DEFAULT '0' COMMENT '双师课堂课程ID',
  `DevId` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
  `Title` varchar(255) NOT NULL DEFAULT '' COMMENT '事件标题',
  `Detail` varchar(4096) NOT NULL DEFAULT '' COMMENT '详细数据',
  `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '添加时间',
  PRIMARY KEY (`Id`),
  KEY `CourseId` (`CourseId`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='双师课堂运行详细日志';

CREATE TABLE IF NOT EXISTS `nccs`.`DevStartingPic`  (
  `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '所属学校ID',
  `Type` tinyint(4) NOT NULL COMMENT '图片类型，0---TM03背景图，1---TM03前景图，2---面板开机图片',
  `User` int(11) NULL DEFAULT NULL COMMENT '上传用户ID',
  `Path` varchar(255) NOT NULL COMMENT '文件路径',
  `SyncVal` int(11) NOT NULL DEFAULT 1 COMMENT '整数同步字',
  PRIMARY KEY (`SchoolID`, `Type`) USING BTREE,
  UNIQUE INDEX `NAME_UNIQUE`(`Path`) USING BTREE
)
ENGINE = InnoDB
CHARACTER SET = utf8;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
