-- MySQL Workbench Synchronization
-- Generated: 2021-8-4 16:53
-- Model: New Model
-- Version: D07.03.01
-- Project: nccs`
-- Author: ww
SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

CREATE TABLE IF NOT EXISTS `nccs`.`EnvironmentalParameters`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `ProtocolFiledName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '参数在协议中对应的字段',
  `Name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '参数名称',
  `Unit` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '单位',
  `ExactValue` float(20, 9) UNSIGNED NOT NULL DEFAULT 1.000000000 COMMENT '精确度',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE INDEX `protocolFiledName`(`ProtocolFiledName`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


DELETE `nccs`.`Users` FROM `nccs`.`Users`  INNER JOIN (SELECT Phone,MIN(User_ID) as User_ID,SchoolID FROM `nccs`.`Users` WHERE Phone IS NOT NULL AND Phone != "" GROUP BY SchoolID, Phone HAVING count( 1 )> 1) as  b on `nccs`.`Users`.Phone=b.Phone and  b.SchoolID=`nccs`.`Users`.SchoolID and `nccs`.`Users`.User_ID!=b.User_ID;
ALTER TABLE `nccs`.`Users` ADD UNIQUE INDEX `Phone_UNIQUE`(`SchoolID`, `Phone`) USING BTREE;

-- SystemLog
ALTER TABLE `SystemLog` DROP INDEX `schoolIndex` ;
ALTER TABLE `SystemLog` ADD INDEX `schoolAt` (`SchoolID`, `at`) USING BTREE ;
ALTER TABLE `SystemLog` DROP PRIMARY KEY, ADD PRIMARY KEY (`id`, `at`);
-- DeviceLog
ALTER TABLE `DeviceLog` ADD COLUMN `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置名称' AFTER `DeviceID`;
ALTER TABLE `DeviceLog` ADD COLUMN `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '用户姓名' AFTER `CtrlUser`;
ALTER TABLE `DeviceLog` DROP INDEX `schoolIndex`;
ALTER TABLE `DeviceLog` ADD INDEX `schoolTime` (`DateTime`, `EndTime`, `SchoolID`) USING BTREE ;
ALTER TABLE `DeviceLog` MODIFY COLUMN `DateTime`  datetime NOT NULL AFTER `DeviceName`, DROP PRIMARY KEY, ADD PRIMARY KEY (`DevLogID`, `DateTime`);
-- DeviceLog.UserName init value
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Desc WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Desc IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Name WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Name IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.User_Sn WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.User_Sn IS NOT NULL;
UPDATE DeviceLog, Users SET DeviceLog.UserName = Users.Phone WHERE DeviceLog.CtrlUser IS NOT NULL AND DeviceLog.CtrlUser = Users.User_ID AND DeviceLog.UserName = '' AND Users.Phone IS NOT NULL;
-- DeviceLog.DeviceName init value
UPDATE DeviceLog, DeviceList SET DeviceLog.DeviceName = CONVERT(convert(DeviceList.Dev_Description USING gbk), CHAR(255)) WHERE DeviceLog.DeviceID IS NOT NULL AND DeviceLog.DeviceID = DeviceList.DevID AND DeviceLog.DeviceName = '' AND DeviceList.Dev_Description IS NOT NULL;
UPDATE DeviceLog, DeviceList SET DeviceLog.DeviceName = DeviceList.Dev_Name WHERE DeviceLog.DeviceID IS NOT NULL AND DeviceLog.DeviceID = DeviceList.DevID AND DeviceLog.DeviceName = '' AND DeviceList.Dev_Name IS NOT NULL;
UPDATE DeviceLog SET DeviceName = DeviceID WHERE DeviceName = '';

CREATE TABLE IF NOT EXISTS `nccs`.`EnvControlDevices`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `EnvCtrlInfoID` int(10) NOT NULL,
  `DeviceID` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE INDEX `ctrlID_devID`(`EnvCtrlInfoID`, `DeviceID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvControlInfo`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT,
  `CtrlType` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '控制类型：温度控制或者其他：1-n，1表示温控',
  `Month` int(10) NOT NULL COMMENT '月份。bit1-bit12表示1月到12月',
  `Weekday` int(10) NOT NULL COMMENT '表示周几。bit1-bit6表示周一到周六，bit0表示周天',
  `StartTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '比如：08:00:00',
  `EndTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '比如：12:00:00',
  `Condition` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '>or=or>=or<or<=',
  `CriticalValue` float(10, 2) NOT NULL COMMENT '阈值',
  `Mode` int(10) NOT NULL COMMENT '比如：空调的制冷或者制热',
  `SchoolID` int(10) NOT NULL,
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
