-- MySQL Workbench Synchronization
-- Generated: 2021-9-23 10:58
-- Model: New Model
-- Version: D07.01.39
-- Project: nccs`
-- Author: youxy
SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

UPDATE `nccs`.`TaskTemplate` SET `TemplateName`='' WHERE `TemplateName` IS NULL;
ALTER TABLE `nccs`.`TaskTemplate` MODIFY COLUMN `TemplateName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' AFTER `idTaskTemplate`;
ALTER TABLE `nccs`.`TaskTemplate` MODIFY COLUMN `Enabled` tinyint(4) NOT NULL DEFAULT 0 AFTER `TemplateName`;

ALTER TABLE `nccs`.`EnvironmentalParameters` DROP INDEX `protocolFiledName`;

ALTER TABLE `nccs`.`EnvironmentalParameters` CHANGE `ProtocolFiledName` `ProtocolFieldName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '参数在协议中对应的字段' AFTER `ID`;
ALTER TABLE `nccs`.`EnvironmentalParameters` ADD UNIQUE INDEX `protocolFieldName`(`ProtocolFieldName`) USING BTREE;

CREATE TABLE IF NOT EXISTS   `nccs`.`RfConfig`(
    `PwrID` tinyint(4) NOT NULL,
    `Name` varchar(45) DEFAULT NULL COMMENT '物联名称',
    `ChildType` int(11) NOT NULL  COMMENT '物联二级类型',
    `DevID` varchar(50) NOT NULL DEFAULT '0' COMMENT '设备ID',
    UNIQUE KEY `uniqueIndex` (`PwrID`,`DevID`) USING BTREE,
    KEY `devIdIndex` (`DevID`) USING BTREE
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物联配置表基于设备';

CREATE TABLE IF NOT EXISTS  `nccs`.`SessionCtrlListType` (
    `id` INT ( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT,
    `SessionID` SMALLINT ( 6 ) NOT NULL,
    `ChildType` INT ( 11 ) NOT NULL,
    `State` INT ( 11 ) DEFAULT NULL,
    `Action` INT ( 11 ) DEFAULT NULL,
    PRIMARY KEY ( `id` ) USING BTREE,
    UNIQUE KEY `SesSubID_UNIQUE` ( `SessionID`, `ChildType` ) USING BTREE,
    KEY `SessionID` ( `SessionID` ) USING BTREE
    ) ENGINE = INNODB AUTO_INCREMENT = 1 DEFAULT CHARSET = utf8;

ALTER TABLE `nccs`.SessionCtrlList ADD DataState int(1);
UPDATE `nccs`.SessionCtrlList SET DataState=1;

CREATE TABLE IF NOT EXISTS `nccs`.`RfChildType` (
    `ID` int(11) NOT NULL AUTO_INCREMENT COMMENT '子类型',
    `RfType` int(11) NOT NULL COMMENT '父类型',
    `Name` varchar(255) NOT NULL COMMENT '子类型名称',
    `SchoolID` int(11) NOT NULL COMMENT '学校id',
    `IsDefault` tinyint(1) NOT NULL COMMENT '0：正常子类，1：默认子类',
    PRIMARY KEY (`ID`),
    UNIQUE KEY `School_Name` (`SchoolID`,`Name`) USING BTREE
    ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

CREATE TABLE IF NOT EXISTS `nccs`.`SensorProduct` (
  `product_id` INT(11) NOT NULL,
  `name` VARCHAR(64) NOT NULL,
  `mod_bus` SMALLINT(6) NOT NULL,
  `vendor_id` INT(11) NOT NULL,
  `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE INDEX `product_index` USING BTREE (`product_id` ASC, `vendor_id` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`SensorVendor` (
  `id` INT(11) UNSIGNED NOT NULL,
  `name` VARCHAR(64) NOT NULL,
  `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
