-- MySQL Workbench Synchronization
-- Generated: 2021-12-28 14:33:28
-- Model: nccs
-- Version: D07.03.08
-- Project: idsteServers
-- Author: youxy(youxy@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';


UPDATE Users SET User_Desc='' WHERE User_Desc IS NULL;
UPDATE Users SET Pass_Word='' WHERE Pass_Word IS NULL;
UPDATE Users SET Dpm_Sn='' WHERE Dpm_Sn IS NULL;
UPDATE Users SET Dpm_Name='' WHERE Dpm_Name IS NULL;
UPDATE Users SET Priority=100 WHERE Priority IS NULL;
UPDATE Users SET PrivilegeList='' WHERE PrivilegeList IS NULL;
UPDATE Users SET ServerSync=1 WHERE ServerSync IS NULL;
UPDATE Users SET User_Type=2 WHERE User_Type IS NULL;
UPDATE Users SET Mgr_Privilege=0 WHERE Mgr_Privilege IS NULL;
UPDATE Users SET Dev_Privilege=0 WHERE Dev_Privilege IS NULL;
UPDATE Users SET Create_Type=0 WHERE Create_Type IS NULL;
UPDATE Users SET IC_Status=0 WHERE IC_Status IS NULL;
UPDATE Users SET Del_Flag=0 WHERE Del_Flag IS NULL;


ALTER TABLE Users MODIFY COLUMN User_Desc VARCHAR(255)  NOT NULL DEFAULT '' COMMENT '用户登录名';
ALTER TABLE Users MODIFY COLUMN Pass_Word VARCHAR(255)  NOT NULL DEFAULT '' COMMENT 'password, encode with PASSWORD()';
ALTER TABLE Users MODIFY COLUMN Priority INT(11)  NOT NULL DEFAULT 100 COMMENT '用户优先级 值越小。优先级越高';
ALTER TABLE Users MODIFY COLUMN PrivilegeList varchar(4096)  NOT NULL DEFAULT '' COMMENT '用户权限列表';
ALTER TABLE Users MODIFY COLUMN ServerSync TINYINT(4)  NOT NULL DEFAULT 1 COMMENT 'Flag for sync data to cloud server, set when data is inserted or updated, clear after the changed data sysnc to cloud server.';
ALTER TABLE Users MODIFY COLUMN User_Type TINYINT(4)  NOT NULL DEFAULT 2 COMMENT '用户类型：\n1：学生\n2：教师\n3：临时人员 \n4：学校管理员 \n5：平台管理员';
ALTER TABLE Users MODIFY COLUMN Mgr_Privilege TINYINT(1)  NOT NULL DEFAULT 0 COMMENT '设备管理权限标志\n0：具有部分权限，需要查询UserDevices表\n1：具有全部权限，无需查询UserDevices表';
ALTER TABLE Users MODIFY COLUMN Dev_Privilege TINYINT(1)  NOT NULL DEFAULT 0 COMMENT '设备使用权限标志\n0：具有部分权限，需要查询UserDevices表\n1：具有全部权限，无需查询UserDevices表';
ALTER TABLE Users MODIFY COLUMN  Create_Type tinyint(1) NOT NULL DEFAULT 0 COMMENT '用户创建类型\n0：手动创建\n1：自动(IC卡同步)创建\n';
ALTER TABLE Users MODIFY COLUMN  IC_Status tinyint(1) NOT NULL DEFAULT 0 COMMENT 'IC卡状态\n0：IC卡正常\n1：IC卡挂失';
ALTER TABLE Users MODIFY COLUMN Dpm_Sn varchar(20) NOT NULL DEFAULT "" COMMENT '部门编号';
ALTER TABLE Users MODIFY COLUMN Dpm_Name varchar(100) NOT NULL  DEFAULT "" COMMENT '部门名称';
ALTER TABLE Users MODIFY COLUMN Del_Flag  tinyint(1) NOT NULL DEFAULT 0 COMMENT 'delete flag:\n0: normal\n1: deleted';
-- 增加updatePwdTime
ALTER TABLE Users ADD COLUMN UpdatePwdTime datetime NOT NULL DEFAULT now() COMMENT '密码更新时间。初始化时间为当前时间';

-- ----------------------------
-- Table structure for DeviceTemplate
-- ----------------------------
CREATE TABLE IF NOT EXISTS `DeviceTemplate`  (
  `ID` int(10) NOT NULL AUTO_INCREMENT COMMENT '模板唯一键值',
  `Name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板的名称',
  `Content` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板的内容',
  `Url` varchar(1028) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '访问模板的url',
  `Sign` int(10) UNSIGNED NOT NULL DEFAULT 0 COMMENT '表示是否有更新',
  `UpdateAt` timestamp(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '更新时间',
  `SchoolID` int(10) NOT NULL COMMENT '学校ID',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 38 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `GraphicSessions` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '图文任务ID',
    `name` varchar(255) NOT NULL,
    `priority` tinyint(5) unsigned NOT NULL DEFAULT '30',
    `forced` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '1表示强制接收，0表示不强制接收',
    `start_time` datetime NOT NULL COMMENT '任务开始时间',
    `stop_time` datetime NOT NULL COMMENT '任务结束时间',
    `start_time_hms` time NOT NULL COMMENT '存放start_time字段的时分秒',
    `time_style` tinyint(4) NOT NULL DEFAULT '0' COMMENT '重复周期，按照bit位重复,bit0表示周天',
    `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '0表示禁止状态，1表示停止状态，2表示运行状态',
    `resource_id` int(10) unsigned NOT NULL COMMENT '图文资源ID',
    `owner` int(11) NOT NULL COMMENT '创建者ID',
    `school_id` int(11) NOT NULL,
    `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
    `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`),
    KEY `start_time_hms_index` (`start_time_hms`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `GraphicSessionMember` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
    `session` int(10) unsigned NOT NULL COMMENT 'IDSessions表id主键值',
    `device` varchar(16) NOT NULL COMMENT '设备ID',
    PRIMARY KEY (`id`),
    UNIQUE KEY `unique_idx` (`device`,`session`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;