-- MySQL Workbench Synchronization
-- Generated: 2022-02-14 14:33:28
-- Model: nccs
-- Version: D07.03.10
-- Project: idsteServers
-- Author: youxy(youxy@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

ALTER TABLE `nccs`.`EnvControlInfo` DROP COLUMN `CtrlType`;
ALTER TABLE `nccs`.`EnvControlInfo` DROP COLUMN `Month`;
ALTER TABLE `nccs`.`EnvControlInfo` DROP COLUMN `Condition`;
ALTER TABLE `nccs`.`EnvControlInfo` DROP COLUMN `CriticalValue`;
ALTER TABLE `nccs`.`EnvControlInfo` DROP COLUMN `Mode`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `Type` int(10) NOT NULL COMMENT '策略类型。1：环境策略' AFTER `ID`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `Name` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '策略的名称' AFTER `Type`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `Conditions` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '{}' COMMENT '策略条件。json格式' AFTER `Name`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `Duration` int(10) NOT NULL COMMENT '满足条件以后需要持续该时间长度才执行任务' AFTER `Conditions`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `Operation` varchar(4096) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '{}' COMMENT '该策略需要执行的操作。json格式' AFTER `Duration`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `EntryTimeType` int(10) NOT NULL COMMENT '生效时间类型 0：表示每天中哪个时间范围执行该策略 1：表示每天中哪个时间点执行该策略' AFTER `Weekday`;
ALTER TABLE `nccs`.`EnvControlInfo` MODIFY COLUMN `StartTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '与EndTime一起作用，比如：08:00:00 EntryTimeType = 0时有效' AFTER `EntryTimeType`;
ALTER TABLE `nccs`.`EnvControlInfo` MODIFY COLUMN `EndTime` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '与StartTime一起作用，比如：12:00:00 EntryTimeType = 0时有效' AFTER `StartTime`;
ALTER TABLE `nccs`.`EnvControlInfo` ADD COLUMN `TimeSpot` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '比如：09:00:00 EntryTimeType = 2时有效' AFTER `EndTime`;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCh2o`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;


CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataCo2`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataHumidity`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataInfrared`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` int(11) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataLight`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE  IF NOT EXISTS `nccs`.`EnvDataNoise`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataPm2dot5`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataRadar`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` int(11) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS `nccs`.`EnvDataTemperature`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

CREATE TABLE IF NOT EXISTS  `nccs`.`EnvDataTvoc`  (
    `SchoolID` int(11) NOT NULL DEFAULT 0 COMMENT '学校id',
    `ReportDate` datetime(0) NOT NULL,
    `DeviceID` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备ID',
    `Val` float(11, 2) NOT NULL,
    UNIQUE INDEX `INDEX`(`SchoolID`, `ReportDate`, `DeviceID`) USING BTREE
    ) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;