-- MySQL Workbench Synchronization
-- Generated: 2022-04-26 14:33:28
-- Model: nccs
-- Version: D07.03.17
-- Project: idsteServers
-- Author:

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

CREATE TABLE IF NOT EXISTS `Student` (
  `Number` varchar(255) NOT NULL DEFAULT '' COMMENT '学生证号码',
  `Name` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
  `College` varchar(255) NOT NULL DEFAULT '' COMMENT '学院',
  `Grade` int(11) NOT NULL DEFAULT '0' COMMENT '年级(毕业年份)',
  `Class` varchar(255) NOT NULL DEFAULT '' COMMENT '专业班级',
  `Mobile` varchar(255) NOT NULL DEFAULT '' COMMENT '手机号码',
  `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '学校ID',
  PRIMARY KEY (`Number`),
  KEY `mobile` (`Mobile`),
  KEY `name` (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学生信息对接表';

CREATE TABLE IF NOT EXISTS `RegisterUser` (
  `UserAccount` varchar(255) NOT NULL DEFAULT '' COMMENT '用户账号（下划线开头的是系统用户）',
  `Phone` varchar(255) NOT NULL DEFAULT '' COMMENT '电话号码',
  `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户ID',
  `UserType` enum('student','teacher','other') NOT NULL DEFAULT 'student' COMMENT '用户类型（student-学生 teacher-教职工 other-其他人员）',
  `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '注册姓名',
  `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学院',
  `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '注册年级',
  `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '注册班级',
  `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学工号',
  `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '注册学校ID',
  `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '注册学校名称',
  `AddTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '注册时间',
  `ActiveTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后参与时间',
  `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '学生匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
  `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
  `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
  `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
  `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
  `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
  `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
  `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
  `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
  `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核已通过 -1-审核未通过）',
  `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
  `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
  `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
  `ReserveTotal` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约次数',
  `ReservePass` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约成功次数',
  `ReserveCancel` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约取消次数',
  `ReserveUse` int(11) NOT NULL DEFAULT '0' COMMENT '预约使用次数',
  `ReserveActive` int(11) NOT NULL DEFAULT '0' COMMENT '教室预约有效数量（列表可见）',
  `ReserveHistory` int(11) NOT NULL DEFAULT '0' COMMENT '历史记录数',
  PRIMARY KEY (`UserAccount`),
  KEY `phone` (`Phone`),
  KEY `userID` (`User_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='注册用户';

CREATE TABLE IF NOT EXISTS `DeviceReserve` (
  `ID` int(11) NOT NULL AUTO_INCREMENT COMMENT '预约ID',
  `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户的用户ID',
  `UserMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '用户手机号码',
  `UserType` enum('student','other','teacher') NOT NULL DEFAULT 'student' COMMENT '用户类型',
  `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
  `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '所属学院',
  `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '所属年级',
  `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '所属班级',
  `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '学工号',
  `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '申请学校ID',
  `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '申请学校名称',
  `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
  `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
  `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
  `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
  `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
  `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
  `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
  `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
  `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
  `MatchSchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学校',
  `ClassID` int(11) NOT NULL DEFAULT '0' COMMENT '设备分区ID',
  `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备分区名称（教学楼）',
  `DeviceID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
  `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备名称（教室）',
  `DeviceDescription` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置',
  `DeviceExt` varchar(255) NOT NULL DEFAULT '' COMMENT '扩展设备ID,英文逗号分割（双师课堂一个教室有两个设备）',
  `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `Reason` varchar(255) NOT NULL DEFAULT '' COMMENT '预约原因',
  `ApplyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '申请时间',
  `ModifyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核未通过 2-审核已通过 -1-审核已过期）',
  `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
  `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
  `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
  `AuditInfo` varchar(255) NOT NULL DEFAULT '' COMMENT '审核备注信息',
  `CancelStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '取消状态（0-未取消  1-用户自己取消 2-管理员取消）',
  `CancelUserID` int(11) NOT NULL DEFAULT '0' COMMENT '取消用户ID （管理员取消才有值）',
  `CancelUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '取消用户姓名（管理员取消才有值）',
  `CancelTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '取消时间',
  `CancelReason` varchar(255) NOT NULL DEFAULT '' COMMENT '取消原因',
  `UseQrCode` varchar(255) NOT NULL DEFAULT '' COMMENT '反向扫码二维码',
  `UseStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '使用状态（0-未使用 1-已使用）',
  `UseDeviceID` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用设备(0-未使用 1-已使用)',
  `UseDeviceExt` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用扩展设备(0-未使用 1-已使用)',
  `UseCount` int(11) NOT NULL DEFAULT '0' COMMENT '使用次数',
  `UseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '使用时间',
  `UseDevice` varchar(255) NOT NULL DEFAULT '' COMMENT '使用设备ID',
  PRIMARY KEY (`ID`),
  KEY `mobile` (`UserMobile`),
  KEY `number` (`UserNumber`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='教室预约';

CREATE TABLE IF NOT EXISTS `DeviceReserveHistory` (
  `ID` int(11) NOT NULL COMMENT '预约ID',
  `User_ID` int(11) NOT NULL DEFAULT '-5' COMMENT '系统用户的用户ID',
  `UserMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '用户手机号码',
  `UserType` enum('student','teacher','other') NOT NULL DEFAULT 'student' COMMENT '用户类型',
  `UserName` varchar(255) NOT NULL DEFAULT '' COMMENT '姓名',
  `UserCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '所属学院',
  `UserGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '所属年级',
  `UserClass` varchar(255) NOT NULL DEFAULT '' COMMENT '所属班级',
  `UserNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '学工号',
  `SchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '申请学校ID',
  `SchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '申请学校名称',
  `MatchStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '匹配状态(0-未匹配 1-匹配成功 -1-匹配失败)',
  `MatchID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配ID（匹配当时 user或student 表中的ID）',
  `MatchName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配姓名',
  `MatchCollege` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学院',
  `MatchGrade` int(11) NOT NULL DEFAULT '2019' COMMENT '匹配年级',
  `MatchClass` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配班级',
  `MatchNumber` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学工号',
  `MatchMobile` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配手机号码',
  `MatchSchoolID` int(11) NOT NULL DEFAULT '0' COMMENT '匹配学校ID',
  `MatchSchoolName` varchar(255) NOT NULL DEFAULT '' COMMENT '匹配学校',
  `ClassID` int(11) NOT NULL DEFAULT '0' COMMENT '设备分区ID',
  `ClassName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备分区名称（教学楼）',
  `DeviceID` varchar(255) NOT NULL DEFAULT '' COMMENT '设备ID',
  `DeviceName` varchar(255) NOT NULL DEFAULT '' COMMENT '设备名称（教室）',
  `DeviceExt` varchar(255) NOT NULL DEFAULT '' COMMENT '扩展设备ID,英文逗号分割（双师课堂一个教室有两个设备）',
  `DeviceDescription` varchar(255) NOT NULL DEFAULT '' COMMENT '设备位置',
  `StartTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `EndTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `Reason` varchar(255) NOT NULL DEFAULT '' COMMENT '预约原因',
  `ApplyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '申请时间',
  `ModifyTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `AuditStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '审核状态（0-未审核  1-审核已通过 -1-审核未通过）',
  `AuditUserID` int(11) NOT NULL DEFAULT '0' COMMENT '审核用户ID',
  `AuditUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '审核用户姓名',
  `AuditTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '审核时间',
  `AuditInfo` varchar(255) NOT NULL DEFAULT '' COMMENT '审核备注信息',
  `CancelStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '取消状态（0-未取消  1-用户自己取消 2-管理员取消）',
  `CancelUserID` int(11) NOT NULL DEFAULT '0' COMMENT '取消用户ID （管理员取消才有值）',
  `CancelUserName` varchar(255) NOT NULL DEFAULT '' COMMENT '取消用户姓名（管理员取消才有值）',
  `CancelTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '取消时间',
  `CancelReason` varchar(255) NOT NULL DEFAULT '' COMMENT '取消原因',
  `UseQrCode` varchar(255) NOT NULL DEFAULT '' COMMENT '反向扫码二维码',
  `UseStatus` tinyint(4) NOT NULL DEFAULT '0' COMMENT '使用状态（0-未使用 1-已使用）',
  `UseDeviceID` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用设备(0-未使用 1-已使用)',
  `UseDeviceExt` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否使用扩展设备(0-未使用 1-已使用)',
  `UseCount` int(11) NOT NULL DEFAULT '0' COMMENT '使用次数',
  `UseTime` bigint(20) NOT NULL DEFAULT '0' COMMENT '使用时间',
  `UseDevice` varchar(255) NOT NULL DEFAULT '' COMMENT '使用设备ID',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='教室预约历史数据';
