-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
-- -----------------------------------------------------
-- Schema nccs
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema nccs
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `nccs` DEFAULT CHARACTER SET utf8 ;
USE `nccs` ;

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_Session_Files`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_Session_Files` (`SessionID` INT, `SessionName` INT, `FileID` INT, `SequenceID` INT, `FileName` INT, `TotalTime` INT, `PlayTime` INT, `Gain` INT, `FileFmt` INT, `FilePath` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device` (`id` INT, `name` INT, `parent` INT, `description` INT, `SchoolID` INT, `rf_invalid` INT, `ipaddress` INT, `ModeName` INT, `ModePriority` INT, `rtsp` INT, `rtsp1` INT, `ProjAlert` INT, `pcCtrl` INT, `mic0` INT, `mic1` INT, `mic2` INT, `mic3` INT, `micChargeStub` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_log`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_log` (`DevLogID` INT, `DeviceID` INT, `DeviceName` INT, `SchoolID` INT, `DateTime` INT, `Event` INT, `CtrlUser` INT, `User_Name` INT, `User_Sn` INT, `MsgContext` INT, `EndTime` INT, `Length` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_mode`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_mode` (`DeviceID` INT, `idBroadcastMode` INT, `Priority` INT, `SchoolID` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_statistic`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_statistic` (`DeviceID` INT, `DeviceName` INT, `StatisticDay` INT, `SchoolID` INT, `power0` INT, `power1` INT, `power2` INT, `power3` INT, `power4` INT, `power5` INT, `power6` INT, `power7` INT, `power8` INT, `power9` INT, `power10` INT, `power11` INT, `power12` INT, `power13` INT, `power14` INT, `power15` INT, `power16` INT, `time0` INT, `time1` INT, `time2` INT, `time3` INT, `time4` INT, `time5` INT, `time6` INT, `time7` INT, `time8` INT, `time9` INT, `time10` INT, `time11` INT, `time12` INT, `time13` INT, `time14` INT, `time15` INT, `time16` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_event`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_event` (`Id` INT, `Name` INT, `SchoolID` INT, `StartTask` INT, `StartTaskName` INT, `EndTask` INT, `EndTaskName` INT, `Config` INT, `Model` INT, `Manufacturer` INT, `ModelName` INT, `Version` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_play_session_time_group`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_play_session_time_group` (`id` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_playing_sessions`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_playing_sessions` (`SessionID` INT, `PlayerID` INT, `PlayingFileID` INT, `FileName` INT, `MultiPort` INT, `CircleLength` INT, `CurrFileProgress` INT, `CurrTotalProgress` INT, `Priority` INT, `Pause` INT, `ScheduleID` INT, `WeekDay` INT, `PlayTime` INT, `Template` INT, `BrdMode` INT, `SessionType` INT, `StreamType` INT, `SchoolID` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_session_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_session_info` (`SessionID` INT, `SessionName` INT, `SessionType` INT, `Priority` INT, `CircleLength` INT, `PlayerID` INT, `BrdMode` INT, `MemberMode` INT, `StreamType` INT, `Owner` INT, `SchoolID` INT, `OwnerName` INT, `PlayMode` INT, `AudioGain` INT, `Template` INT, `FileID` INT, `PlayerAddress` INT, `PlayType` INT, `PlayerType` INT, `SubID` INT, `State` INT, `Action` INT, `Type` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_timed_session_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_timed_session_info` (`SessionID` INT, `SessionName` INT, `SessionType` INT, `Priority` INT, `BrdMode` INT, `StreamType` INT, `Owner` INT, `OwnerName` INT, `PlayMode` INT, `Template` INT, `FileID` INT, `PlayTime` INT, `WeekDay` INT, `TempFlag` INT, `ScheduleID` INT, `SchoolID` INT, `Type` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_timetable`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_timetable` (`Id` INT, `DevId` INT, `Dev_Name` INT, `UserId` INT, `SchoolID` INT, `User_Name` INT, `WeekDay` INT, `Start` INT, `End` INT, `Type` INT, `OneTime` INT, `Sync` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_timetable_v1`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_timetable_v1` (`ID` INT, `Dev_Name` INT, `User_Flag` INT, `User_Name` INT, `User_ID` INT, `User_Desc` INT, `Zone` INT, `CourseName` INT, `TermName` INT, `SectionStart` INT, `SectionEnd` INT, `WeekDay` INT, `WeekStart` INT, `WeekEnd` INT, `WeekType` INT, `Active` INT, `Type` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_task`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_task` (`DevID` INT, `SessionID` INT, `MultiPort` INT, `SesType` INT, `StreamType` INT, `SchoolID` INT, `SessionName` INT);

-- -----------------------------------------------------
-- function func_IcCard_Authorize
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_IcCard_Authorize`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_IcCard_Authorize`(
          ic_card varchar(50),
          device_id varchar(50)
         ) RETURNS int(11)
BEGIN
    declare uid int default null;
    declare ret int default null;
    declare storage_key varchar(32) default null;
    declare last_key varchar(32) default '';
    declare last_event int default null;
    declare new_event int default 0;
    declare card varchar(10) default null;
    declare cardHex varchar(10) default null;
    declare cardSwitch varchar(10) default null;
    declare realcard varchar(10) default null;

    set card = LPAD(ltrim(rtrim(ic_card)), 10, 0);
    set cardHex = LPAD(conv(ic_card,10, 16), 8, 0);
    set cardHex = concat(substring(cardHex, 7,2), substring(cardHex, 5, 2), substring(cardHex, 3, 2), substring(cardHex, 1, 2));
    set cardSwitch = LPAD(conv(cardHex, 16, 10), 10, 0);
    select User_ID, IcCard into uid, realcard from Users
           where (LPAD(ltrim(rtrim(Users.IcCard)), 10, 0) = card or
				  LPAD(ltrim(rtrim(Users.IcCard)), 10, 0) = cardSwitch
                  ) limit 1;
    if (uid is not null) and (uid > 0) then
        select func_IcCard_Authorize_bg(realcard, device_id) into ret;
    else
        set ret = uid;
    end if;
    return ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_IcCard_Authorize_bg
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_IcCard_Authorize_bg`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_IcCard_Authorize_bg`(
          card varchar(50),
          DeviceID varchar(50)
         ) RETURNS int(11)
BEGIN
    declare uid int default null; 
    declare tt int default null; 
    declare udid int default null; 
    declare tid int default null;  
    declare nowday INT default null; 
    declare weeknow int(4) default 0;
    declare tp varchar(10) default null;
    declare devname, devstat varchar(32) default null;
    declare usersn, userphone varchar(20) default null;
    declare seczone, secname varchar(32) default null;
    declare schoolID int default 0; 
    
    DECLARE section CURSOR
    FOR
    select `zone`, `name` from SectionTable WHERE CURTIME() >= `start` and CURTIME() <= `end` group by `zone`;

    set @isMgr = false;
    select User_ID, Dev_Privilege, Mgr_Privilege, User_Name, Pass_Word, Privilege, User_Sn, Phone, SchoolID into uid, @dpri, @mpri, @username, @passwd, @privilege, usersn, userphone, schoolID from Users
                    where IcCard=card and
                          Users.IC_Status=0 and 
                          (Users.User_Expiry is null or 
                           Users.User_Expiry > now());
    if(uid is null )then
        return null;
    elseif(uid=0) or (@dpri=1)then
        return uid;
    elseif(@username is not null) and (@passwd is not null) then
        if(@privilege&0x40000000 = 0x40000000) then
            return uid;
        end if;
        if(@privilege&1 = 1) then
            if(@mpri = 1) then
                return uid;
            end if;
            set @isMgr = true;
        end if;
    end if;
    
    select a.UserDevID into udid from UserDevices a
				  left join Users b on b.User_ID = uid
                  where a.UserID = uid and
                        a.DevID = DeviceID and
                        (
                            (a.Pri&1=1 and
                                (
                                    (
                                        b.User_Type=3 and
                                        (
                                            b.User_Expiry is null or
                                            b.User_Expiry > now()
                                        )
                                    ) or
                                    b.User_Type <3
                                )
                            ) or
                            ((@isMgr=true) and (a.Pri&2=2))
                        )
                  LIMIT 1;
	
	
    if(udid is not null) then
		return uid;
    end if;
    
    select InfoValue into tt from BaseInfo where InfomationID=280 and SchoolID=schoolID;
    if(tt is null) or (tt <= 0) then
		return null;
    end if;
    
    select `intv` into nowday from tmp_storage where `key` = 'nowday';
    
    select `Id` into tid from Timetable 
					where 	`UserID` = uid and
							`DevId` = DeviceID and
                            (
                                `OneTime` = 0 and
                                `WeekDay` = nowday and
                                time(now()) > subtime(time(`Start`), '00:30:00') and
                                time(now()) < time(`End`)
                            ) or
                            (
                                `OneTime` = 1 and
                                now() > subtime(`Start`, '00:30:00') and
                                now() < `End`
                            )
					limit 1;
		
	if (tid is not null) then
        return uid;
	end if;

    select `strv`, `intv` into tp, weeknow from tmp_storage where `key` = 'week';
    select `name`, `power` into devname,  devstat from v_device where `id` = DeviceID;
	
    open section;
    repeat
        fetch section into seczone, secname;
        select `ID` into tid from TimetableV1 where 
                   ((`Type`='tmp_phone' and `User_Flag` = userphone) or (`Type`<>'tmp_phone' and `User_Flag` = usersn)) 
                   and `Dev_Name` = devname
                   and `Zone` = seczone
                   and  weeknow  between `WeekStart` and `WeekEnd`
                   and `WeekType` in (tp , 'all')
                   and `WeekDay` = nowday
                   and `secname` between `SectionStart` and `SectionEnd`
                   limit 1;
        if (tid is not null) then
            return uid;
        end if;
    until done end repeat;
    close section;
	
    return null;    
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_dev_stream
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_dev_stream`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_dev_stream`( 
                                    dev_id varchar(50),
                                    stream_type int) RETURNS tinyint(1)
begin

if (ASCII(dev_id) = 0x30) then
     return false;
end if;    

if (LEFT(dev_id,2)='59') then
     return true;
end if;

if ((stream_type & 0x02)  <> 0) then
    if (ASCII(right(dev_id, 9)) <> 0x38) then
         return false;
     end if;    
end if;

return true;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_mode_daytime
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_mode_daytime`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_mode_daytime`( 
          weekday tinyint, 
          checked_time datetime,
          last_time datetime,
          cur_time datetime
         ) RETURNS tinyint(1)
begin
declare cur_weekday tinyint default null;
declare checked_date date;


if (last_time >= cur_time) then
    return false;
end if;    


if  (weekday = 0) then

    if (checked_time  > last_time) and (checked_time <= cur_time) then 
        return true;
    end if;    
else
    
     if (time(last_time) > time(cur_time)) then
         
         if (time(checked_time) > time(last_time) ) then
              set checked_date = date(last_time);
         else 
              if (time(checked_time) <= time(cur_time)) then
                    set checked_date = date(cur_time);
              else
                    return false;
               end if ;    
          end if;
      else
          
          if (time(checked_time) <= time(last_time) )  or 
              (time(checked_time) > time(cur_time))  then
              
              return false;
           end if;   
           
           set checked_date = date(cur_time);
      end if;
      
       
      select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = checked_date;

      if cur_weekday is null then 
           set cur_weekday = weekday(checked_date);
       end if;
     
    if (weekday & (0x01 << cur_weekday)  <> 0 ) then 
        
        return true;
   end if;    
end if;

return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_mode_enabled
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_mode_enabled`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_mode_enabled`( modeid int , 
      PlayTime time,
      PlayDate date) RETURNS tinyint(1)
begin
declare cur_weekday tinyint default null;
declare checked_date date;
declare modeactive boolean default false;
declare modeenable boolean default false;
declare modestarttime datetime  default null;
declare modestoptime datetime  default null;
declare modetimestype tinyint default null;
declare matched boolean default false;

select Active, Enabled, StartTime, StopTime,TimeStyle into modeactive, modeenable, modestarttime, modestoptime, modetimestype 
            from BroadcastMode where idBroadcastMode = modeid limit 1;
   
  if (modeenable = false) then
     return false;
  end if;   
 
 if (modetimestype = 0) then
     if (PlayDate = date(modestarttime) ) then
         set matched = true;
      end if;
 else
     select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = PlayDate;
      if cur_weekday is null then 
           set cur_weekday = weekday(PlayDate);
       end if;       
       if (modetimestype & (0x01 << cur_weekday)  <> 0 ) then 
        
        set matched = true;
        end if;
   end if;    
    
if (matched = false) then 
    
    if  (modeactive = false) then
        return false;
    end if;
 end if;
 
 if  (modeactive = false)  and (PlayTime < time(modestarttime)) then
     return false;
 end if;    

if (PlayTime <  time(modestoptime)) then
    return true;
end if;    
return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_session_daytime
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_session_daytime`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_session_daytime`(
          brdmode int,
          weekday tinyint, 
          checked_time datetime,
          last_time datetime,
          cur_time datetime
         ) RETURNS tinyint(1)
begin

declare cur_weekday tinyint default null;
declare checked_date date;
declare activemode boolean default false;


if (last_time >= cur_time) then
    return false;
end if;    

if (brdmode > 0) then
     select Active into activemode from BroadcastMode where idBroadcastMode = brdmode limit 1;
     if  not (activemode = true) then
        return false;
     end if;
end if;     


if  (weekday > 6) then

    if (checked_time  > last_time) and (checked_time <= cur_time) then 
        return true;
    end if;    
else
    
     if (time(last_time) > time(cur_time)) then
         
         if (time(checked_time) > time(last_time) ) then
              set checked_date = date(last_time);
         else 
              if (time(checked_time) <= time(cur_time)) then
                    set checked_date = date(cur_time);
              else
                    return false;
               end if ;    
          end if;
      else
          
          if (time(checked_time) <= time(last_time) )  or 
              (time(checked_time) > time(cur_time))  then
              
              return false;
           end if;   
           
           set checked_date = date(cur_time);
      end if;
      
       
      select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = checked_date;

      if cur_weekday is null then 
           set cur_weekday = weekday(checked_date);
       end if;
     
    if (brdmode > 0) or (weekday = cur_weekday)  then 
        
        return true;
   end if;    
end if;

return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_task_privilege
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_task_privilege`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `func_check_task_privilege`(
                 user int, 
                 StreamType tinyint,
                 SysEnabled tinyint, 
                 RfDevCtrl BINARY(16)) RETURNS tinyint(1)
BEGIN
	declare Priv int default null;

    if (user is null or user = 0) then
		return true;
    end if;

	select privilege into Priv from Users where User_ID = user;

	if Priv is null then
		return false;
  end if;

	if ((Priv & 0x01) = 0) and (SysEnabled is not null) then         
		return false;
  end if;

	if ((Priv & 0x100) = 0) and (StreamType <> 0) then
		return false;
  end if;
        
  if ((Priv & 0x10000) = 0)  and (RfDevCtrl is not null) and (RfDevCtrl <> 0x00000000000000000000000000000000) then 
		return false;
  end if;

	return true;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_dulicate_device
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_dulicate_device`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `func_dulicate_device`(
    SrcDevice varchar(50),
    DstDevice varchar(50),
    mask tinyint unsigned) RETURNS varchar(4096)
BEGIN
    declare base_cfg varchar(4096) default null;
    declare name_cfg varchar(4096) default null;
    declare cfg varchar(4096) default null;
    declare ret int default null;
    -- optional and offset
    declare dst_op, src_op, os1, os2 int default 0;
    declare dst_cfg varchar(4096) default '';
    declare c1, c2, c3, c4 varchar(4096) default '';

    if ((mask & 0x01) <> 0) then  

       delete from DeviceExt where DevId = DstDevice ;
       INSERT INTO DeviceExt (DevID , Name , Config) 
	   (select DstDevice, Name, Config from DeviceExt where DevID = SrcDevice) 
	   on duplicate key update Config = values(Config);

       select hex(Dev_configuration) into base_cfg from DeviceList where DevID = SrcDevice;
       select hex(Dev_configuration) into dst_cfg from DeviceList where DevID = DstDevice;

       if (base_cfg is null) or (length(base_cfg) < 960) then
           return '';
       end if;
       
       if ((mask & 0x02) <> 0) then
           set name_cfg = SUBSTRING(base_cfg, 1, 256); 
       else
           set name_cfg = SUBSTRING(dst_cfg, 1, 256); 
       end if;
        
       set cfg = CONCAT(name_cfg, substring(base_cfg, 257, 704));
       if(length(base_cfg) > 960) then
           set src_op = conv(concat(substring(base_cfg, 963, 2), substring(base_cfg, 961, 2)), 16, 10);
           if(length(dst_cfg) > 960) then
                set dst_op = conv(concat(substring(dst_cfg, 963, 2), substring(dst_cfg, 961, 2)), 16, 10);
           end if;
           set os1 = 965;
           set os2 = 965;
-- projector
			if(src_op & 0x01) then
                set c2 = substring(base_cfg, os1, 668);
                set os1 = os1 + 668;
                if(dst_op & 0x01) then
                    set os2 = os2 + 668;
                else
                    set dst_op = dst_op | 1;
                end if;
			elseif(dst_op & 0x01) then
                set c2 = LPAD('', 668, 0);
                set os2 = os2 + 668;
			end if;
-- pc
			if(src_op & 0x02) and (mask & 0x20) then
				set c3 = substring(base_cfg, os1, 132);
			elseif (dst_op & 0x02) then
                set c3 = substring(dst_cfg, os2, 132);
            end if;
            
            if(src_op & 0x02) then
				set os1 = os1 + 132;
            end if;
            if(dst_op & 0x02) then
				set os2 = os2 + 132;
            end if;
            if(length(c3) > 0) then
				set dst_op = dst_op | 0x02;
            end if;
-- other
           if(length(base_cfg) > os1) then
                set c4 = substring(base_cfg, os1);
           end if;
-- option          
            set dst_op = dst_op & 0xfff3;
            set dst_op = dst_op | (src_op & 0x0c);
            set c1 = LPAD(conv(dst_op, 10, 16), 4, 0);
            set c1 = concat(substring(c1, 3, 2), substring(c1, 1, 2));
       end if;
       set cfg = concat(cfg, c1, c2, c3, c4);
    end if;

    if ((mask & 0x08) <> 0) then
        update DeviceList set Parent = (select Parent from (select * from DeviceList) as tmp_table 
										where DevID = SrcDevice) where DevID = DstDevice;
    end if;

    if ((mask & 0x10) <> 0) then
        delete from UserDevices where DevID = DstDevice;
        insert into UserDevices(UserID, DevID, Pri)
            select UserID, DstDevice, Pri from UserDevices where DevID = SrcDevice and Pri!=0;

        insert into Timetable(UserId, DevId, WeekDay, Start, End)
        select `UserId`,DstDevice,`WeekDay`,`Start`,`End` from Timetable where DevId=SrcDevice;
    end if;

    if ((mask & 0x04) <> 0) then
		delete from SessionDevice where DeviceID = DstDevice;
        insert into SessionDevice(DeviceID, SessionID, KeyIndex, DevDisabled) 
               select DstDevice, SessionID, KeyIndex, DevDisabled from SessionDevice where DeviceID = SrcDevice;
        
		delete from BrdModeMember where DeviceID = DstDevice;
        insert into BrdModeMember(BrdModeID, DeviceID) 
               select BrdModeID, DstDevice from BrdModeMember where DeviceID = SrcDevice;

        delete from DevCtrlSchedule where DevID = DstDevice;
        insert into DevCtrlSchedule(DevID,ActionTime,`Action`,WeekDay,State,ExtArgs,`Disable`)
               select DstDevice,ActionTime,`Action`,WeekDay,State,ExtArgs,`Disable` from DevCtrlSchedule where DevID = SrcDevice; 
               
        insert into Timetable(DevId, UserId, WeekDay, Start, End, Type)
            select DstDevice, UserId, WeekDay, Start, End, Type from Timetable where DevId = SrcDevice;
    end if;

    if ((mask & 0x40) <> 0) then
		update DeviceList set RfInvalid = (select RfInvalid from (select * from DeviceList) as tmp_table where DevID = SrcDevice) where DevID = DstDevice;
    end if;

    if ((mask & 0x80) <> 0) then
        delete from UserDevices where DevID = SrcDevice;
        delete from DevCtrlSchedule where DevID = SrcDevice;
        delete from SessionDevice where DeviceID = SrcDevice;
        delete from BrdModeMember where DeviceID = SrcDevice;
        delete from DeviceList where DevID = SrcDevice;
    end if;
    return cfg;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_get_dev_mode
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_get_dev_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_get_dev_mode`( 
                                    dev_id varchar(50),
                                    checked_daytime datetime) RETURNS int(11)
begin
   declare checkday date;
   declare checktime time;
   declare checkweek int;
   declare ret int default null;
   
   set checkday = date(checked_daytime);
   set checktime = time(checked_daytime);
   
   select AlteredScheduleDay into checkweek from AlternateDate where SpecialDate = checkday;
    if checkweek is null then 
           set checkweek = weekday(checkday);
    end if;       

   
   select  BroadcastMode.idBroadcastMode into ret from BroadcastMode, BrdModeMember 
                  where (BrdModeMember.DeviceID =  dev_id) and
                        (BrdModeMember.BrdModeID = BroadcastMode.idBroadcastMode) and
                        (BroadcastMode.Enabled = true) and
                        (    (  (  (  (BroadcastMode.TimeStyle = 0 and checkday = date(BroadcastMode.StartTime)) or
                                      (BroadcastMode.TimeStyle & (0x01 << checkweek)  <> 0) 
								   ) and  (checktime >= time(BroadcastMode.StartTime))
                                ) or (BroadcastMode.Active = true)
						     ) 
                            and   
                            (   (BroadcastMode.TimeStyle = 0 and checkday <> date(BroadcastMode.StartTime)) or  
							    ( (BroadcastMode.TimeStyle <> 0) and (BroadcastMode.TimeStyle & (0x01 << checkweek)  = 0)) or
                                (checktime < time(BroadcastMode.StopTime))
							)
                        )
      order by BroadcastMode.Priority limit 1;
  
  return ret;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_get_mediafile_Owner
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_get_mediafile_Owner`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_get_mediafile_Owner`(mediaID int) RETURNS int(11)
BEGIN
  -- 查询文件（夹）最顶层的归属用户（只能查询用户文件夹及其文件）
  -- 用于判断文件（夹）是否挂载在用户文件夹下，而不是系统文件夹下
  declare medid int default null;
  declare pid int default null;
  declare own int default null;
  declare foldflag tinyint default null;
  declare sid int default null;

  -- 查询文件（夹）
  select mediafile.Parent,mediafile.`Owner`,mediafile.Sysfolder,mediafile.MediaID,mediafile.SchoolID into pid,own,foldflag,medid,sid from MediaFiles mediafile where mediafile.MediaID = mediaID limit 1;
  -- 没找到 或者 查询到了“用户文件”系统文件夹
  if(medid is null) or ((foldflag is not null) and (foldflag = 2)) then
	set own = -1;
	return own;
  else
    -- 查询到了系统创建的用户名最顶层文件夹
	if((foldflag is not null) and (foldflag = 1)) then
	  if(own is null) then
		set own = -1;
	  end if;
	  return own;
	else
      -- 利用PID递归查询文件（夹）
      while((pid is not null) and (pid <> 0)) do
		select mediafile.Parent,mediafile.`Owner`,mediafile.Sysfolder into pid,own,foldflag from MediaFiles mediafile where mediafile.MediaID = pid and mediafile.SchoolID = sid limit 1;
        -- 没找到 或者 查询到了“用户文件”系统文件夹
	    if(medid is null) or ((foldflag is not null) and (foldflag = 2)) then
		  set own = -1;
		  return own;
	    else
          -- 查询到了系统创建的用户名最顶层文件夹
		  if((foldflag is not null) and (foldflag = 1)) then
		    if(own is null) then
			  set own = -1;
			end if;
			return own;
		  end if;
		end if;
	  end while;
	end if;
    -- 最后没有找到
	set own = -1;
	return own;
  end if;
END$$

DELIMITER ;


-- -----------------------------------------------------
-- function func_qrcode_request
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_qrcode_request`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_qrcode_request`(
	devid varchar(50),
    opcode varchar(50)) RETURNS varchar(128) CHARSET utf8
BEGIN
    declare app varchar(50) default 'wx';
	set @uuid = 'unknow';
    select Description into @uuid from BaseInfo where InfomationID=313 and SchoolID = 0;
    set @host = 'www.idste.net';
    select Description into @host from BaseInfo where InfomationID=336 and SchoolID = 0;
    select Description into app from BaseInfo where InfomationID=579 and SchoolID = 0;
    return concat('https://', @host , '/s/' , opcode, '?u=', @uuid , '&i=' , devid, '&t=', unix_timestamp(now()), '&o=', app);
END$$

DELIMITER ;


-- -----------------------------------------------------
-- function get_dev_mode
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_dev_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_dev_mode`(dev_id varchar(50)) RETURNS int(11)
begin
 declare ret int default 0;
 
 select BrdModeMember.BrdModeID into ret from BrdModeMember
                left join BroadcastMode on BroadcastMode.idBroadcastMode = BrdModeMember.BrdModeID
                where (BrdModeMember.DeviceID = dev_id) and (BroadcastMode.Active = true) 
                 order by    BroadcastMode. Priority LIMIT 1;       
                 
 return ret;                
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_dev_session
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_dev_session`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_dev_session`(dev_id varchar(50), sessionId smallint unsigned, 
                                                                                       playerid varchar(50), SesMode int) RETURNS tinyint(1)
begin
 declare modeid int default 0;
 declare sespriority int default null;
 declare modepriority int default null;
 declare modemembertype boolean default false;
 
 set modeid = get_dev_mode(dev_id) ;
 
 select Priority into modepriority from BroadcastMode where idBroadcastMode = modeid LIMIT 0, 1;
 select Priority , MemberMode into sespriority, modemembertype from
                               PlaySessions where PlaySessions.SessionID = sessionId LIMIT 0, 1;
 
  
 if (modeid = SesMode and  modemembertype = true) then
 
     return true;
  end if;
  
 if not (modeid > 0 and  SesMode <> modeid and sespriority >= modepriority) then
    if exists (select DeviceID from SessionDevice 
                 where (SessionDevice.DeviceID = dev_id) and (SessionDevice.SessionID = sessionId) and (not DevDisabled = 1)) then
                 
                 return true;
      else
                return exists (select DeviceList .DevID from DeviceList , PlayerKeys 
                            where DeviceList .DevID =  dev_id and PlayerKeys.PlayerID = playerid and
                            PlayerKeys.GroupDisable = 0 and 
                            ((PlayerKeys.GroupID <> 0) and sp_dev_belong_group(DeviceList.DevID, PlayerKeys.GroupID)));

    end if;  
 end if;

  
  return false;                                
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_idle_port
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_idle_port`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_idle_port`() RETURNS int(10) unsigned
begin

declare idle_port int unsigned;

set idle_port = 7000;

emp_loop: loop   
if not exists(select * from PlayerStatus where PlayPort = idle_port) then   
leave emp_loop;
end if;
set idle_port = idle_port + 2;
end loop;

return  idle_port;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_idle_sessionid
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_idle_sessionid`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_idle_sessionid`(video boolean) RETURNS smallint(5) unsigned
begin

declare ses_id smallint unsigned default 1;

 emp_loop: loop   
if not exists(select SessionID from PlaySessions where SessionID = ses_id) then   
leave emp_loop;
end if;
set ses_id = ses_id + 1;
end loop;

return  ses_id;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_network
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_network`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_network`(ipaddr varchar(50)) RETURNS int(10) unsigned
BEGIN

declare src_ip int unsigned;
declare mask int unsigned;
declare proxy int unsigned;
declare netid int unsigned;
declare ret int default 0;

DECLARE done INT DEFAULT 0;   
DECLARE cur1 CURSOR FOR SELECT 
    idSubNetwork, inet_aton(NetMask), inet_aton(IpAddress) 
    FROM SubNetwork;   
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done=1;   

set src_ip = inet_aton(ipaddr);
OPEN cur1;   

emp_loop: LOOP   

FETCH cur1 INTO netid, mask, proxy;   

if ((src_ip & mask) = (proxy & mask))  and (mask <> 0) then
set ret = netid;
set done = 1;


end if;

IF done=1 THEN   
LEAVE emp_loop;   
END IF;   
END LOOP emp_loop;   
CLOSE cur1;   

return  ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_rtmp_url
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_rtmp_url`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_rtmp_url`(dev_id varchar(50)) RETURNS varchar(256) CHARSET utf8
BEGIN
	declare srsSrv varchar(128) default null;
    declare a int default 0;
    declare b varchar(128) default null;
    declare flag boolean default true;
	declare cur_tmp CURSOR FOR select `id`,`server` from `SrsServer` order by id asc;
	declare continue handler for NOT FOUND set flag=false;
	
	OPEN cur_tmp;
	fetchLoop:loop
		fetch cur_tmp into a,b;
		if(flag=false) then
			leave fetchLoop;
		end if;
        insert into SrsServerStatus values(a, b, 0) 
			on duplicate key update 
				id=values(id), `server`=values(`server`);
	end loop;
	close cur_tmp;

    select `server` into srsSrv from SrsServerStatus order by count asc limit 1;
    if(srsSrv is null) then
		insert into SrsServer (`name`, `server`) values('localhost', inet_ntoa(get_srv_ip())) 
			on duplicate key update `server`=values(`server`);
        set srsSrv = inet_ntoa(get_srv_ip());
    end if;
    update MediaFiles, PlayListFiles, PlaySessions 
        set MediaFiles.FilePath=concat(concat(concat('rtmp://', srsSrv), '/bw803/') , dev_id) 
        where PlayListFiles.FileID=MediaFiles.MediaID
            and PlayListFiles.SessionID = PlaySessions.SessionID
            and PlaySessions.PlayerID=dev_id;
    return concat(concat(concat('rtmp://', srsSrv), '/bw803/') , dev_id);
END$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_check_group
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_check_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `sp_check_group`(
           check_group int,
           ses smallint unsigned,
           keyno int,
           checkstate bool,
           depth int)
begin
    declare gid int;
    declare cur1 cursor for select ClassID from DevClasses where Parent = check_group;
    declare continue handler for sqlstate '02000' set gid = null; 


      if (depth < 5) then
            if  (checkstate = true) then
                 insert into SessionDevice(DeviceID, SessionID, KeyIndex)
                       select `DeviceList`.`DevID`, ses, keyno from DeviceList where parent = check_group
                on duplicate key update SessionID = values(SessionID);                
            else
                 delete SessionDevice from SessionDevice , DeviceList 
                       where SessionDevice.SessionID = ses and SessionDevice.KeyIndex = keyno 
                                     and SessionDevice.DeviceID = DeviceList.DevID and
                                      DeviceList.parent = check_group;
            end if;  

       open cur1; 
       fetch cur1 into gid; 

       while ( gid is not null )  do
         call sp_check_group(gid, ses, keyno, checkstate, depth+1); 
         fetch cur1 into gid; 
       end while; 
 end if; 
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_copy_mode
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_copy_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_copy_mode`(
    old_modeid int,
    new_enabled boolean
    )
begin
declare new_modeid int default null;

declare old_session smallint default null;
declare new_session smallint default null;

declare mode_task_cur cursor for select  SessionID  from PlaySessions where BrdMode = old_modeid;  
declare continue handler for sqlstate '02000' set old_session = null;

  
  insert into BroadcastMode(ModeName, Priority, Enabled, StartTime, StopTime, TimeStyle, Active)  
           (select concat(ModeName, " copy"), Priority, new_enabled, StartTime, StopTime, TimeStyle, false from BroadcastMode where idBroadcastMode=old_modeid) ;
   
   set new_modeid = last_insert_id();
   
   if (new_modeid is not null) then
      
      insert into BrdModeMember(BrdModeID,DeviceID)  (select new_modeid,DeviceID from BrdModeMember where BrdModeID =  old_modeid);
      
      
      open  mode_task_cur;  
       fetch mode_task_cur into old_session;  
         
      while ( old_session is not null) do
            set new_session = get_idle_sessionid(false);
             insert into PlaySessions(SessionID,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                                                MemberMode,StreamType,SysEnabled,RfDevCtrl,PlayMode, AudioGain)
                                   (select new_session,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,new_modeid,
                                                                MemberMode,StreamType,SysEnabled,RfDevCtrl,PlayMode,AudioGain
                                                                from PlaySessions where SessionID = old_session);
            
            insert into PlaySessionTime(SessionID,WeekDay,PlayTime,TempFlag) 
                          (select new_session,WeekDay,PlayTime,TempFlag from PlaySessionTime where SessionID = old_session);
            
            insert into PlayListFiles(FileID,SequenceID,SessionID,Duration,KeyIndex,PlayerID) 
                          (select FileID,SequenceID,new_session,Duration,KeyIndex,PlayerID from PlayListFiles where SessionID = old_session);
                          
             insert into SessionDevice(DeviceID,SessionID,KeyIndex,DevDisabled)
                           (select  DeviceID,new_session,KeyIndex,DevDisabled from  SessionDevice where SessionID = old_session);
             
             fetch mode_task_cur into old_session;  

      end while;
      close mode_task_cur;
   end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_copy_template
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_copy_template`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_copy_template`(
    old_template int
    )
begin
declare new_template int default null;

declare old_session smallint default null;
declare new_session smallint default null;

declare task_cur cursor for select  SessionID  from PlaySessions 
        where (Template = old_template) and ((BrdMode is null) or (BrdMode = 0)) and ((SessionType = 0) or (SessionType = 8));   
declare continue handler for sqlstate '02000' set old_session = null;

  
  insert into TaskTemplate(TemplateName, Enabled)  
           (select concat(TemplateName, " copy"), 0 from TaskTemplate where idTaskTemplate = old_template) ;
   
   set new_template = last_insert_id();
   
   if (new_template is not null) then

      open  task_cur;  
      fetch task_cur into old_session;  
         
      while ( old_session is not null) do
            set new_session = get_idle_sessionid(false);
             insert into PlaySessions(SessionID,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                      MemberMode,StreamType,SysEnabled,RfDevCtrl, `Owner`, PlayMode, AudioGain, Template)
                                   (select new_session,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                           MemberMode,StreamType,SysEnabled, RfDevCtrl, `Owner`, PlayMode, AudioGain, new_template
                                           from PlaySessions where SessionID = old_session);
            
            insert into PlaySessionTime(SessionID,WeekDay,PlayTime,TempFlag) 
                          (select new_session,WeekDay,PlayTime,TempFlag from PlaySessionTime where SessionID = old_session);
            
            insert into PlayListFiles(FileID,SequenceID,SessionID,Duration,KeyIndex,PlayerID) 
                          (select FileID,SequenceID,new_session,Duration,KeyIndex,PlayerID from PlayListFiles where SessionID = old_session);
                          
             insert into SessionDevice(DeviceID,SessionID,KeyIndex,DevDisabled)
                           (select  DeviceID,new_session,KeyIndex,DevDisabled from  SessionDevice where SessionID = old_session);
             
             fetch task_cur into old_session;  

      end while;
      close task_cur;
   end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_media_class
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_media_class`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_media_class`(classid int)
BEGIN
      UPDATE MediaFiles SET ClassID=0 WHERE (Parent=classid) ;
	DELETE FROM MediaClasses WHERE ID = classid;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_media_file
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_media_file`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_media_file`(userid int, media_id int)
BEGIN

	declare tmp_own int default null;
	declare tmp_priority int;
	declare tmp_mediaid int default null;
	declare mediacurs cursor for select MediaID from MediaFiles where Parent = media_id;
	declare continue handler for not found,1329,sqlstate '02000' set tmp_mediaid = null;

	select func_get_mediafile_Owner(media_id) into tmp_own;
	

	if((tmp_own = userid) or (userid = 0)) then

		open mediacurs;
		fetch mediacurs into tmp_mediaid;
			
		while(tmp_mediaid is not null) do
			call sp_del_media_file(userid,tmp_mediaid);
			fetch mediacurs into tmp_mediaid;
		end while;
		
		
		if ( not exists (select PlayingFileID from  PlayingSessions where PlayingFileID = media_id)) then
			DELETE FROM PlayListFiles WHERE FileID = media_id;
			DELETE FROM MediaFiles WHERE MediaID = media_id; 
		end if;

	end if;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_session_class
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_session_class`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_session_class`(classid int)
BEGIN
	UPDATE PlaySessions SET ClassID=NULL WHERE ClassID = classid;
	DELETE FROM SessionClasses WHERE (ClassID=classid);
END$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_delete_device
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_delete_device`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_delete_device`(dev_id varchar(50))
begin

delete from UserDevices where DevID = dev_id;
delete from DevCtrlSchedule where DevID = dev_id;
delete from SessionDevice where DeviceID = dev_id;
delete from BrdModeMember where DeviceID = dev_id;
delete from DeviceList where DevID = dev_id;


delete from PlaySessions where PlayerID = dev_id;
delete from PlayerKeys where PlayerID = dev_id;
delete from Players where PlayerID = dev_id;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_delete_group
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_delete_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_delete_group`(GrpID int)
begin
delete from PlayGroupDevices where GroupID = GrpID;
delete from PlaySessionGroups where GroupID = GrpID;
delete from PlayGroups where GroupID = GrpID;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function sp_dev_belong_group
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_dev_belong_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_dev_belong_group`(dev varchar(50), groupid int) RETURNS tinyint(1)
begin
    declare ret boolean default false ;
    declare gid int default 0;
   
   set gid  = groupid;
   
      if (groupid is null) or (groupid = 0) then
       return true;
    end if;
    
    if (dev is null)  then
       return false;
    end if;
    
   select Parent into gid  from  DeviceList   where DevID = dev;
   
   if (gid = groupid) then
       return true;
    end if;
    
    while (( gid is not null ) and (gid <> 0))  do
         select Parent into gid from  DevClasses   where ClassID = gid;
 
         if (gid = groupid) then
               return true;
          end if; 
    end while;        
   return false;   
end$$

DELIMITER ;


-- -----------------------------------------------------
-- function sp_dev_belong_logic_class
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_dev_belong_logic_class`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_dev_belong_logic_class`(dev varchar(50), logic_class_id int) RETURNS tinyint(1)
begin
    declare gid int default 0;

    if (dev is null) then
        return false;
    end if;

    select class_id into gid  from  LogicClassDevices  where class_id = logic_class_id and device = dev;

    if (gid = logic_class_id) then
        return true;
     end if;

    return false;
end$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_device_statistics
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_device_statistics`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_device_statistics`()
BEGIN

select count(*) into @devices_close from DeviceStatus where State_SysPower = 0;
select count(*) into @devices_open from DeviceStatus where State_SysPower = 1;
select count(*) into @devices_disable from DeviceStatus where State_SysPower = 2;
select count(*) into @devices_all from DeviceList;

select strv into @devices_old from tmp_storage where `key`='devices_now';
set @devices_now = concat(@devices_all, ',', @devices_close, ',' ,
                          @devices_open, ',', @devices_disable);

if (@devices_old is null) or (@devices_old <> @devices_now) then
    insert into tmp_storage (`key`, `strv`) values('devices_now', @devices_now)
        on duplicate key update `strv` = values(`strv`);
    insert into DeviceLog (DeviceID, Event, DateTime, MsgContext)
        values ('0000000000', 13, now(), @devices_now);
end if;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_fetch_playing_file
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_fetch_playing_file`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `sp_fetch_playing_file`(
    sesid smallint,
    file_seq int,
    remained_time int)
begin
	declare random tinyint default 0;
	declare maxid int default 0;

    select PlayMode into random from PlaySessions where  SessionID = sesid;

	if (random > 0) then
		if (remained_time <> 0) then            
           select max(b.SequenceID) into maxid from PlayListFiles b
				   left join MediaFiles c on b.FileID = c.MediaID 
					where b.SessionID = sesid;
		   set maxid = round( rand() * maxid);
		   select b.FileID, c.TotalTime,b.SequenceID, c.Gain, c.FilePath, @@datadir, c.FileName    
                   from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		               where  (b.SessionID = sesid) and (b.SequenceID >= maxid) 
                   order by SequenceID limit 0, 1;
		else
			if (file_seq = 0) then
			    select max(SequenceID) into maxid from PlayListFiles where SessionID = sesid;
			    set maxid = round( rand() * maxid);
			    select b.FileID, c.TotalTime,1, c.Gain, c.FilePath, @@datadir, c.FileName    
                   from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		           where  (b.SessionID = sesid) and (b.SequenceID >= maxid) order by SequenceID limit 0, 1;
			else
                select null; 
            end if;
		  end if;
    else 
        select b.FileID, c.TotalTime,b.SequenceID, c.Gain, c.FilePath, @@datadir , c.FileName   
               from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		       where  (b.SessionID = sesid) and (b.SequenceID >= file_seq) order by SequenceID limit 0, 1;
    end if;
	 
    

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_get_dev_scheduled_tasks
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_get_dev_scheduled_tasks`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_get_dev_scheduled_tasks`(
        schoolID int(11),
        dev_id varchar(50),
        start_datetime datetime,
        stop_datetime datetime)
label_pro: begin
         declare check_day date;
         declare check_start time;
         declare check_stop time;
         declare check_week int;

         set check_day = date(start_datetime);
         set check_start = time(start_datetime);
         set check_stop = time(stop_datetime);
         
         select AlteredScheduleDay into check_week from AlternateDate where SpecialDate = check_day and SchoolID = schoolID;
         if check_week is null then 
              set check_week = weekday(check_day);
         end if;    
         
		 select InfoValue into @templateNow from BaseInfo where InfomationID = 0x101 and SchoolID = schoolID limit 1;
         
         if (check_day <> date(stop_datetime)) or (check_start >= check_stop) then
             leave label_pro;
         end if;  
        
		select PlaySessionTime.ScheduleID as ScheduleID, PlaySessionTime.TempFlag as TempFlag, time(PlaySessionTime.PlayTime) as PlayTime, 
                PlaySessions.SessionID as SessionID,PlaySessions.SessionName as SessionName, 
                devmode.idBroadcastMode as DeviceMode, devmode.ModeName as DeviceModeName,
				taskmode.idBroadcastMode as TaskMode, 
				case when (taskmode.idBroadcastMode is not null) then taskmode.Priority else PlaySessions.Priority end as TaskPriority, 
                devmode.Priority as DevPriority, PlaySessions.SessionType as SessionType,PlaySessions.StreamType as StreamType
            FROM nccs.PlaySessions 
                left join PlaySessionTime on PlaySessionTime.SessionID =  PlaySessions.SessionID
                left join BroadcastMode devmode on devmode.idBroadcastMode = func_get_dev_mode(dev_id,  DATE_ADD(check_day, INTERVAL time(PlayTime) HOUR_SECOND ))
				left join BroadcastMode taskmode on taskmode.idBroadcastMode = PlaySessions.BrdMode
                left join SessionDevice on SessionDevice.DeviceID = dev_id and SessionDevice.SessionID = PlaySessions.SessionID
                left join BrdModeMember on BrdModeID = PlaySessions.BrdMode and BrdModeMember.DeviceID = dev_id
			where (    (check_start <= time(PlaySessionTime.PlayTime) and check_stop > time(PlaySessionTime.PlayTime)) and 
					   (    (    ((taskmode.idBroadcastMode is null) or (taskmode.idBroadcastMode = 0)) and 
                                 (check_week = PlaySessionTime.WeekDay) and
                                 ((PlaySessions.Priority < devmode.Priority) or (devmode.Priority is null))
                            ) or 
							(taskmode.idBroadcastMode = devmode.idBroadcastMode) or 
                            (   ((devmode.Priority is null) or (devmode.Priority > taskmode.Priority) ) and  
								(taskmode.Enabled = true) and
							    
								(
                                    (  (  (  (taskmode.TimeStyle = 0 and check_day = date(taskmode.StartTime)) or
                                             (taskmode.TimeStyle & (0x01 << check_week)  <> 0) 
								          ) and  (time(PlaySessionTime.PlayTime) >= time(taskmode.StartTime))
                                       ) or (taskmode.Active = true)
						            ) 
                                    and   
                                    (   (taskmode.TimeStyle = 0 and check_day <> date(taskmode.StartTime)) or  
							            ( (taskmode.TimeStyle <> 0) and (taskmode.TimeStyle & (0x01 << check_week)  = 0)) or
                                        (time(PlaySessionTime.PlayTime) < time(taskmode.StopTime))
							        )
								)
                            )
						) and 
						(
							( ((PlaySessions.MemberMode is null) or (PlaySessions.MemberMode = 0)) and (SessionDevice.SessionDevID is not null) ) or
							( (PlaySessions.MemberMode > 0) and (BrdModeMember.DevIDMode is not null))
						) 
					and ((PlaySessions.Template is null) or (PlaySessions.Template=@templateNow))
				  )
			 order by PlayTime;
end$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_ipcall_check
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_ipcall_check`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_ipcall_check`()
BEGIN
    delete from IpCall where IpCall.status='idle'
        and (webrtcUpdate is null or addtime(IpCall.webrtcUpdate,  '00:00:10') < now()
             or IpCall.webrtcUpdate > now());

	update IpCall,CallWaiter set IpCall.`status`='idle'
		where IpCall.`status` <> 'idle'
			and ((addtime(CallWaiter.`updateAt`, 10) < now() 
					and IpCall.waiter = CallWaiter.id)
				or (addtime(IpCall.webrtcUpdate, 10) < now()) 
				or (addtime(IpCall.ringing, 30) < now()
					and IpCall.webrtcStatus <> 'running')); 
	update DeviceDesiredStaus set IpCall = 0 where IpCall = 3 and addtime(IpCallEvent, 3) < now();
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_player_keepalive
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_player_keepalive`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_player_keepalive`(
    devid varchar(50),
    player_type tinyint,   
    player_status tinyint, 
    actual_ses int , 
    keymap int,           
    key_type tinyint,  
    ip_addr varchar(50)
    )
BEGIN
    declare net_id int;
    declare key_index int;
    declare group_en tinyint;
    declare dev_en tinyint;
    
if ((player_type <> 2) or exists(select PlayerID from Players where PlayerID = devid)) then
   

    insert into Players(PlayerID, PlayerType ) values (devid, player_type)
        on duplicate key update PlayerType= values(PlayerType);
    
    set net_id = get_network(ip_addr);

    if(not exists(select PlayerID from PlayerStatus where PlayerID = devid)) then
        insert into PlayerStatus(PlayerID, SessionID, ActualSesID, IpAddress, NetID, PlayType)
            values (devid, actual_ses, actual_ses, ip_addr, net_id, player_type);
    end if;
    
    update   PlayerStatus set PlayPort = get_idle_port() where PlayPort is null and PlayerID = devid;


    if ((player_type <> 0) and (player_type <> 8)) then
        set @sesid = 0;
        if (player_status <> 0) then
            select SessionID into @sesid from PlaySessions where PlayerID = devid limit 1;
        end if;
        if (player_status = 1) then
            update PlayerStatus set SessionID = @sesid, ScheduleID=null, IpAddress=ip_addr, ActualSesID=actual_ses, NetID = net_id where PlayerID = devid;
        else
            update PlayerStatus set SessionID = @sesid,IpAddress=ip_addr, ActualSesID=actual_ses, NetID = net_id where PlayerID = devid;
        end if;

         
        insert into PlayerAlive(PlayerID, ReFreshTime) values(devid, now()) 
            on duplicate key update ReFreshTime=values(ReFreshTime);
    else
        update PlayerStatus set ActualSesID=actual_ses, IpAddress=ip_addr, NetID=net_id where PlayerID = devid;
    end if;

    if (player_type = 1) then

        
        set  key_index = 0;
        while (key_index < 16) do
            if (keymap & (0x01 << key_index) <> 0) then
                if (key_type = 0) then
                    set group_en = 0;
                    set dev_en = 1;
                else
                    set dev_en = 0;
                    set group_en = 1;
                end if;    
            else
                set dev_en = 1;
                set group_en = 1;
            end if;
 
    
            insert into PlayerKeys(PlayerID, `Index`, GroupDisable, DevDisable)  values (devid, key_index + 1, group_en, dev_en)
                on duplicate key update GroupDisable=values(GroupDisable), DevDisable=values(DevDisable) ;
 
		    set  key_index =key_index + 1;

        end while;

    end if;
end if; 
end$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_send_dev_cfg_cmd
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_send_dev_cfg_cmd`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_send_dev_cfg_cmd`(
    devid VARCHAR(50),
    Ipaddr VARCHAR(50),
    devcfg VARCHAR(16384),
    devname VARCHAR(32),
    devlocation VARCHAR(96)
    )
BEGIN
    declare tmp int;
    if(devname is null) then
		set devname = '';
	end if;
    if(devlocation is null) then
		set devlocation = '';
	end if;
    set tmp = device_config(Ipaddr, devid, devcfg, devname, devlocation);
END$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_update_realtime_session
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_update_realtime_session`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_update_realtime_session`()
BEGIN
declare done int default false;
declare bw803 varchar(16) default null;
declare stop_bw803 cursor for select PlayerID from PlayingSessions where SesType=10 and CircleLength > 0 and CurrTotalProgress > CircleLength;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;

UPDATE PlayingSessions
SET
    CurrTotalProgress = (CASE
        WHEN CurrTotalProgress IS NULL THEN 1
        ELSE CurrTotalProgress + 1
    END)
WHERE
    SesType = 10;

open stop_bw803;
REPEAT
	FETCH stop_bw803 into bw803;
	if not done then
		update PlayerStatus set SessionID=0 where PlayerID=bw803;
	end if;
until done
END REPEAT;

close stop_bw803;
END$$

DELIMITER ;


-- -----------------------------------------------------
-- procedure sp_create_sub_table
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_create_sub_table`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_create_sub_table`(y INT(11))
BEGIN
	declare tName varchar(50) default '';
	DECLARE yearMax int(11) DEFAULT YEAR(NOW())+1;
	DECLARE yearMin int(11) DEFAULT 2010;
	IF y < yearMin THEN
   set y=yearMin;
END IF;
while y < yearMax  do
		set tName=concat('DevicePower',y);
		SET @param1 =concat('CREATE table IF NOT EXISTS ', tName, ' like ', 'DevicePower');
PREPARE stmt1 FROM @param1;
EXECUTE stmt1;
DEALLOCATE PREPARE stmt1;
set y=y+1;

end while;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_create_sub_table
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_update_sub_table`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_update_sub_table`(t_name VARCHAR(255),sqlStr VARCHAR(1000))
BEGIN
declare done int default false;
declare temp_name varchar(64) default null;
declare cur cursor for select  TABLE_NAME  from information_schema.TABLES where TABLE_NAME like concat(t_name,'%');
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;

open cur;
REPEAT
FETCH cur into temp_name;
	if not done then
				SET @param1=replace(sqlStr,'?',temp_name);
PREPARE stmt1 FROM @param1;
EXECUTE stmt1;
DEALLOCATE PREPARE stmt1;
end if;
until done
END REPEAT;

close cur;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- View `nccs`.`v_Session_Files`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_Session_Files` ;
DROP TABLE IF EXISTS `nccs`.`v_Session_Files`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_Session_Files` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`b`.`FileID` AS `FileID`,`b`.`SequenceID` AS `SequenceID`,`c`.`FileName` AS `FileName`,`c`.`TotalTime` AS `TotalTime`,`b`.`Duration` AS `PlayTime`,`c`.`Gain` AS `Gain`,`c`.`FileFmt` AS `FileFmt`,`c`.`FilePath` AS `FilePath` from ((`nccs`.`PlaySessions` `a` left join `nccs`.`PlayListFiles` `b` on((`a`.`SessionID` = `b`.`SessionID`))) left join `nccs`.`MediaFiles` `c` on((`b`.`FileID` = `c`.`MediaID`))) where (`b`.`FileID` is not null);

-- -----------------------------------------------------
-- -----------------------------------------------------
-- View `nccs`.`v_device`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device` ;
DROP TABLE IF EXISTS `nccs`.`v_device`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device` AS select `nccs`.`DeviceList`.`DevID` AS `id`,`nccs`.`DeviceList`.`Dev_Name` AS `name`,`nccs`.`DeviceList`.`Parent` AS `parent`,`nccs`.`DeviceList`.`Ip` AS `ipaddress`,`nccs`.`DeviceList`.`SchoolID` AS `SchoolID`,convert(`nccs`.`DeviceList`.`Dev_Description` using gb2312) AS `description`,`nccs`.`DeviceList`.`RfInvalid` AS `rf_invalid`,`nccs`.`BroadcastMode`.`ModeName` AS `ModeName`,`v_device_mode`.`Priority` AS `ModePriority`,if((isnull(`nccs`.`DeviceList`.`RtspUrl`) or isnull(`nccs`.`DeviceList`.`RtspSub`)),NULL,'set') AS `rtsp`,if((isnull(`nccs`.`DeviceList`.`RtspUrl1`) or isnull(`nccs`.`DeviceList`.`RtspSub1`)),NULL,'set') AS `rtsp1`,if(((`nccs`.`DeviceList`.`ProjWatermark` <> 0) and (`nccs`.`DeviceList`.`ProjWatermark` < `nccs`.`DeviceList`.`ProjUsedTime`)),`nccs`.`DeviceList`.`ProjUsedTime`,NULL) AS `ProjAlert`,if((isnull(`nccs`.`DeviceList`.`PcIp`) or isnull(`nccs`.`DeviceList`.`PcPort`) or isnull(`nccs`.`DeviceList`.`PcMainPasswd`)),NULL,'set') AS `pcCtrl` from ((`nccs`.`DeviceList` left join `nccs`.`v_device_mode` on((`nccs`.`DeviceList`.`DevID` = `v_device_mode`.`DeviceID`))) left join `nccs`.`BroadcastMode` on((`nccs`.`BroadcastMode`.`idBroadcastMode` = `v_device_mode`.`idBroadcastMode`))) where (not((`nccs`.`DeviceList`.`DevID` like '68%')));

-- -----------------------------------------------------
-- View `nccs`.`v_device_log`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_log` ;
DROP TABLE IF EXISTS `nccs`.`v_device_log`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_log` AS select `a`.`DevLogID` AS `DevLogID`,`a`.`DeviceID` AS `DeviceID`,`c`.`Dev_Name` AS `DeviceName`,`a`.`SchoolID` AS `SchoolID`,`a`.`DateTime` AS `DateTime`,`a`.`Event` AS `Event`,`a`.`CtrlUser` AS `CtrlUser`,ifnull(`b`.`User_Desc`,`b`.`User_Name`) AS `User_Name`,`b`.`User_Sn` AS `User_Sn`,`a`.`MsgContext` AS `MsgContext`,`a`.`EndTime` AS `EndTime`,(case `a`.`EndTime` when NULL then NULL else timediff(`a`.`EndTime`,`a`.`DateTime`) end) AS `Length` from ((`nccs`.`DeviceLog` `a` left join `nccs`.`Users` `b` on((`b`.`User_ID` = `a`.`CtrlUser`))) left join `nccs`.`DeviceList` `c` on((`c`.`DevID` = `a`.`DeviceID`))) order by `a`.`DevLogID` desc;

-- -----------------------------------------------------
-- View `nccs`.`v_device_mode`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_mode` ;
DROP TABLE IF EXISTS `nccs`.`v_device_mode`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_mode` AS select `result`.`DeviceID` AS `DeviceID`,`result`.`idBroadcastMode` AS `idBroadcastMode`,`result`.`Priority` AS `Priority`,`result`.`SchoolID` AS `SchoolID` from (select `nccs`.`BrdModeMember`.`DeviceID` AS `DeviceID`,`nccs`.`BroadcastMode`.`idBroadcastMode` AS `idBroadcastMode`,`nccs`.`BroadcastMode`.`Priority` AS `Priority`,`nccs`.`DeviceList`.`SchoolID` AS `SchoolID` from ((`nccs`.`DeviceList` left join `nccs`.`BrdModeMember` on((`nccs`.`DeviceList`.`DevID` = `nccs`.`BrdModeMember`.`DeviceID`))) left join `nccs`.`BroadcastMode` on((`nccs`.`BroadcastMode`.`idBroadcastMode` = `nccs`.`BrdModeMember`.`BrdModeID`))) where (`nccs`.`BroadcastMode`.`Active` = 1) order by `nccs`.`BroadcastMode`.`Priority`,`nccs`.`BroadcastMode`.`idBroadcastMode` limit 0,1000000) `result` group by `result`.`DeviceID`;

-- -----------------------------------------------------
-- View `nccs`.`v_device_statistic`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_statistic` ;
DROP TABLE IF EXISTS `nccs`.`v_device_statistic`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_statistic` AS select `c`.`DeviceID` AS `DeviceID`,`c`.`DeviceName` AS `DeviceName`,`c`.`StatisticDay` AS `StatisticDay`,`c`.`SchoolID` AS `SchoolID`,conv(substr(`c`.`power`,1,8),16,10) AS `power0`,conv(substr(`c`.`power`,9,8),16,10) AS `power1`,conv(substr(`c`.`power`,17,8),16,10) AS `power2`,conv(substr(`c`.`power`,25,8),16,10) AS `power3`,conv(substr(`c`.`power`,33,8),16,10) AS `power4`,conv(substr(`c`.`power`,41,8),16,10) AS `power5`,conv(substr(`c`.`power`,49,8),16,10) AS `power6`,conv(substr(`c`.`power`,57,8),16,10) AS `power7`,conv(substr(`c`.`power`,65,8),16,10) AS `power8`,conv(substr(`c`.`power`,73,8),16,10) AS `power9`,conv(substr(`c`.`power`,81,8),16,10) AS `power10`,conv(substr(`c`.`power`,89,8),16,10) AS `power11`,conv(substr(`c`.`power`,97,8),16,10) AS `power12`,conv(substr(`c`.`power`,105,8),16,10) AS `power13`,conv(substr(`c`.`power`,113,8),16,10) AS `power14`,conv(substr(`c`.`power`,121,8),16,10) AS `power15`,conv(substr(`c`.`power`,129,8),16,10) AS `power16`,conv(substr(`c`.`time`,1,8),16,10) AS `time0`,conv(substr(`c`.`time`,9,8),16,10) AS `time1`,conv(substr(`c`.`time`,17,8),16,10) AS `time2`,conv(substr(`c`.`time`,25,8),16,10) AS `time3`,conv(substr(`c`.`time`,33,8),16,10) AS `time4`,conv(substr(`c`.`time`,41,8),16,10) AS `time5`,conv(substr(`c`.`time`,49,8),16,10) AS `time6`,conv(substr(`c`.`time`,57,8),16,10) AS `time7`,conv(substr(`c`.`time`,65,8),16,10) AS `time8`,conv(substr(`c`.`time`,73,8),16,10) AS `time9`,conv(substr(`c`.`time`,81,8),16,10) AS `time10`,conv(substr(`c`.`time`,89,8),16,10) AS `time11`,conv(substr(`c`.`time`,97,8),16,10) AS `time12`,conv(substr(`c`.`time`,105,8),16,10) AS `time13`,conv(substr(`c`.`time`,113,8),16,10) AS `time14`,conv(substr(`c`.`time`,121,8),16,10) AS `time15`,conv(substr(`c`.`time`,129,8),16,10) AS `time16` from (select `a`.`DeviceID` AS `DeviceID`,`b`.`Dev_Name` AS `DeviceName`,`a`.`SchoolID` AS `SchoolID`,`a`.`StatisticDay` AS `StatisticDay`,hex(`a`.`UsedTime`) AS `time`,hex(`a`.`PowerConsumed`) AS `power` from (`nccs`.`DeviceStatistic` `a` left join `nccs`.`DeviceList` `b` on((`b`.`DevID` = `a`.`DeviceID`)))) `c`;

-- -----------------------------------------------------
-- View `nccs`.`v_event`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_event` ;
DROP TABLE IF EXISTS `nccs`.`v_event`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_event` AS select `a`.`Id` AS `Id`,`a`.`Name` AS `Name`,`a`.`SchoolID` AS `SchoolID`,`a`.`StartTask` AS `StartTask`,`b`.`SessionName` AS `StartTaskName`,`a`.`EndTask` AS `EndTask`,`c`.`SessionName` AS `EndTaskName`,hex(`a`.`Config`) AS `Config`,`a`.`Model` AS `Model`,`d`.`Manufacturer` AS `Manufacturer`,`d`.`Model` AS `ModelName`,`a`.`Version` AS `Version` from (((`nccs`.`Event` `a` left join `nccs`.`PlaySessions` `b` on(((`b`.`SessionID` = `a`.`StartTask`) and (`b`.`SchoolID` = `a`.`SchoolID`)))) left join `nccs`.`PlaySessions` `c` on(((`c`.`SessionID` = `a`.`EndTask`) and (`c`.`SchoolID` = `a`.`SchoolID`)))) left join `nccs`.`EventModel` `d` on((`d`.`id` = `a`.`Model`)));

-- -----------------------------------------------------
-- View `nccs`.`v_play_session_time_group`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_play_session_time_group` ;
DROP TABLE IF EXISTS `nccs`.`v_play_session_time_group`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_play_session_time_group` AS (select `a`.`SessionID` AS `SessionID`,cast(`a`.`PlayTime` as time) AS `PlayTime`,group_concat(`a`.`WeekDay` separator ',') AS `WeekDay`,group_concat(`a`.`TempFlag` separator ',') AS `TempFlag`,group_concat(`a`.`ScheduleID` separator ',') AS `ScheduleID` from `nccs`.`PlaySessionTime` `a` group by `a`.`SessionID`,`a`.`PlayTime`);

-- -----------------------------------------------------
-- View `nccs`.`v_playing_sessions`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_playing_sessions` ;
DROP TABLE IF EXISTS `nccs`.`v_playing_sessions`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_playing_sessions` AS select `a`.`SessionID` AS `SessionID`,`a`.`PlayerID` AS `PlayerID`,`a`.`PlayingFileID` AS `PlayingFileID`,`b`.`FileName` AS `FileName`,`a`.`MultiPort` AS `MultiPort`,`a`.`CircleLength` AS `CircleLength`,`a`.`CurrFileProgress` AS `CurrFileProgress`,`a`.`CurrTotalProgress` AS `CurrTotalProgress`,`a`.`Priority` AS `Priority`,`a`.`Pause` AS `Pause`,`a`.`ScheduleID` AS `ScheduleID`,`d`.`WeekDay` AS `WeekDay`,cast(`d`.`PlayTime` as time) AS `PlayTime`,`c`.`Template` AS `Template`,`a`.`BrdMode` AS `BrdMode`,`a`.`SesType` AS `SessionType`,`a`.`StreamType` AS `StreamType`,`c`.`SchoolID` AS `SchoolID` from (((`nccs`.`PlayingSessions` `a` left join `nccs`.`MediaFiles` `b` on((`a`.`PlayingFileID` = `b`.`MediaID`))) left join `nccs`.`PlaySessions` `c` on((`c`.`SessionID` = `a`.`SessionID`))) left join `nccs`.`PlaySessionTime` `d` on((`d`.`ScheduleID` = `a`.`ScheduleID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_session_info`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_session_info` ;
DROP TABLE IF EXISTS `nccs`.`v_session_info`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_session_info` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`a`.`SessionType` AS `SessionType`,`a`.`Priority` AS `Priority`,`a`.`CircleLength` AS `CircleLength`,`a`.`PlayerID` AS `PlayerID`,`a`.`BrdMode` AS `BrdMode`,`a`.`MemberMode` AS `MemberMode`,`a`.`StreamType` AS `StreamType`,`a`.`Owner` AS `Owner`,`a`.`SchoolID` AS `SchoolID`,if(isnull(`d`.`User_Desc`),`d`.`User_Name`,`d`.`User_Desc`) AS `OwnerName`,`a`.`PlayMode` AS `PlayMode`,`a`.`AudioGain` AS `AudioGain`,`a`.`Template` AS `Template`,`b`.`FileID` AS `FileID`,`c`.`IpAddress` AS `PlayerAddress`,`c`.`PlayType` AS `PlayType`,`e`.`PlayerType` AS `PlayerType`,`f`.`ChildType` AS `ChildType`,`f`.`State` AS `State`,`f`.`Action` AS `Action`,(case when ((`f`.`ChildType` is not null) or (`a`.`StreamType` = 0)) then 'ctrl' else 'brd' end) AS `Type` from (((((`nccs`.`PlaySessions` `a` left join `nccs`.`PlayListFiles` `b` on(((`b`.`SessionID` = `a`.`SessionID`) and (`b`.`SequenceID` = 0)))) left join `nccs`.`PlayerStatus` `c` on((`c`.`PlayerID` = `a`.`PlayerID`))) left join `nccs`.`Users` `d` on((`d`.`User_ID` = `a`.`Owner`))) left join `nccs`.`Players` `e` on((`e`.`PlayerID` = `a`.`PlayerID`))) left join `nccs`.`SessionCtrlListType` `f` on((`a`.`SessionID` = `f`.`SessionID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_timed_session_info`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_timed_session_info` ;
DROP TABLE IF EXISTS `nccs`.`v_timed_session_info`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_timed_session_info` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`a`.`SessionType` AS `SessionType`,`a`.`Priority` AS `Priority`,`a`.`BrdMode` AS `BrdMode`,`a`.`StreamType` AS `StreamType`,`a`.`Owner` AS `Owner`,`a`.`OwnerName` AS `OwnerName`,`a`.`PlayMode` AS `PlayMode`,`a`.`Template` AS `Template`,`a`.`FileID` AS `FileID`,`d`.`PlayTime` AS `PlayTime`,`d`.`WeekDay` AS `WeekDay`,`d`.`TempFlag` AS `TempFlag`,`d`.`ScheduleID` AS `ScheduleID`,`a`.`SchoolID` AS `SchoolID`,`a`.`Type` AS `Type` from (`nccs`.`v_play_session_time_group` `d` left join `nccs`.`v_session_info` `a` on((`d`.`SessionID` = `a`.`SessionID`))) where (`a`.`SessionType` in (0,8));

-- -----------------------------------------------------
-- View `nccs`.`v_timetable`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_timetable` ;
DROP TABLE IF EXISTS `nccs`.`v_timetable`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_timetable` AS select `a`.`Id` AS `Id`,`a`.`DevId` AS `DevId`,`b`.`Dev_Name` AS `Dev_Name`,`a`.`UserId` AS `UserId`,`a`.`SchoolID` AS `SchoolID`,ifnull(`c`.`User_Desc`,`c`.`User_Name`) AS `User_Name`,`a`.`WeekDay` AS `WeekDay`,`a`.`Start` AS `Start`,`a`.`End` AS `End`,`a`.`Type` AS `Type`,`a`.`OneTime` AS `OneTime`,`a`.`Sync` AS `Sync` from ((`nccs`.`Timetable` `a` left join `nccs`.`DeviceList` `b` on((`a`.`DevId` = `b`.`DevID`))) left join `nccs`.`Users` `c` on((`c`.`User_ID` = `a`.`UserId`)));

-- -----------------------------------------------------
-- View `nccs`.`v_timetable_v1`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_timetable_v1` ;
DROP TABLE IF EXISTS `nccs`.`v_timetable_v1`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_timetable_v1` AS select `a`.`ID` AS `ID`,`a`.`Dev_Name` AS `Dev_Name`,`a`.`User_Flag` AS `User_Flag`,`a`.`User_Name` AS `User_Name`,`b`.`User_ID` AS `User_ID`,if(isnull(`b`.`User_Desc`),(case `a`.`Type` when 'tmp_phone' then concat('Phone:',`a`.`User_Flag`) else concat('User:',`a`.`User_Flag`) end),`b`.`User_Desc`) AS `User_Desc`,`a`.`Zone` AS `Zone`,`a`.`CourseName` AS `CourseName`,`a`.`TermName` AS `TermName`,`a`.`SectionStart` AS `SectionStart`,`a`.`SectionEnd` AS `SectionEnd`,`a`.`WeekDay` AS `WeekDay`,`a`.`WeekStart` AS `WeekStart`,`a`.`WeekEnd` AS `WeekEnd`,`a`.`WeekType` AS `WeekType`,`a`.`Active` AS `Active`,`a`.`Type` AS `Type` from (`nccs`.`TimetableV1` `a` left join `nccs`.`Users` `b` on(((`a`.`User_Flag` = `b`.`User_Sn`) or (`a`.`User_Flag` = `b`.`Phone`))));

-- -----------------------------------------------------
-- View `nccs`.`v_device_task`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_task` ;
DROP TABLE IF EXISTS `nccs`.`v_device_task`;
USE `nccs`;
CREATE  OR REPLACE VIEW `v_device_task` AS select `device_session_list`.`DevID` AS `DevID`,`device_session_list`.`SessionID` AS `SessionID`,`device_session_list`.`MultiPort` AS `MultiPort`,`device_session_list`.`SesType` AS `SesType`,`device_session_list`.`StreamType` AS `StreamType`,`device_session_list`.`SchoolID` AS `SchoolID`,`device_session_list`.`SessionName` AS `SessionName` from (select `nccs`.`DeviceList`.`DevID` AS `DevID`,`SessionList`.`SessionID` AS `SessionID`,`SessionList`.`MultiPort` AS `MultiPort`,`SessionList`.`SesType` AS `SesType`,`SessionList`.`StreamType` AS `StreamType`,`SessionList`.`SessionName` AS `SessionName`,`SessionList`.`SchoolID` AS `SchoolID`,`SessionList`.`PlayBeginTime` AS `PlayBeginTime` from ((((`nccs`.`DeviceList` left join `nccs`.`v_device_mode` on((`v_device_mode`.`DeviceID` = `nccs`.`DeviceList`.`DevID`))) left join (select `nccs`.`PlaySessions`.`SessionID` AS `SessionID`,`nccs`.`PlaySessions`.`SchoolID` AS `SchoolID`,`nccs`.`PlaySessions`.`Priority` AS `Priority`,`nccs`.`PlaySessions`.`PlayerID` AS `PlayerID`,`nccs`.`PlayingSessions`.`MultiPort` AS `MultiPort`,`nccs`.`PlaySessions`.`BrdMode` AS `BrdMode`,`nccs`.`PlaySessions`.`MemberMode` AS `MemberMode`,`nccs`.`PlaySessions`.`SessionType` AS `SesType`,`nccs`.`PlaySessions`.`StreamType` AS `StreamType`,`nccs`.`PlaySessions`.`SessionName` AS `SessionName`,`nccs`.`PlayingSessions`.`PlayBeginTime` AS `PlayBeginTime` from (`nccs`.`PlayingSessions` join `nccs`.`PlaySessions` on((`nccs`.`PlayingSessions`.`SessionID` = `nccs`.`PlaySessions`.`SessionID`)))) `SessionList` on(((`func_check_dev_stream`(`nccs`.`DeviceList`.`DevID`,`SessionList`.`StreamType`) = TRUE) and (((`SessionList`.`MemberMode` = FALSE) and isnull(`v_device_mode`.`Priority`)) or (`SessionList`.`Priority` < `v_device_mode`.`Priority`) or (`SessionList`.`BrdMode` = `v_device_mode`.`idBroadcastMode`))))) left join `nccs`.`SessionDevice` on(((`nccs`.`SessionDevice`.`DeviceID` = `nccs`.`DeviceList`.`DevID`) and (`nccs`.`SessionDevice`.`SessionID` = `SessionList`.`SessionID`) and (`nccs`.`SessionDevice`.`DevDisabled` <> 1)))) left join `nccs`.`PlayerKeys` on(((`nccs`.`PlayerKeys`.`PlayerID` = `SessionList`.`PlayerID`) and (`nccs`.`PlayerKeys`.`GroupDisable` = 0)))) where ((`nccs`.`SessionDevice`.`DeviceID` is not null) or ((`SessionList`.`BrdMode` = `v_device_mode`.`idBroadcastMode`) and (`SessionList`.`MemberMode` = TRUE)) or ((`nccs`.`PlayerKeys`.`logic_class_id` is not null) and `sp_dev_belong_logic_class`(`nccs`.`DeviceList`.`DevID`,`nccs`.`PlayerKeys`.`logic_class_id`))) order by `nccs`.`DeviceList`.`DevID`,`SessionList`.`Priority`,`SessionList`.`PlayBeginTime`,`SessionList`.`SessionID` limit 0,1000000) `device_session_list` group by `device_session_list`.`DevID`;

DELIMITER $$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`BrdModeMember_AFTER_DELETE` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`BrdModeMember_AFTER_INSERT` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_update1` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devclasses_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devclasses_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceList_AFTER_INSERT` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceList_AUPD` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devicelist_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_DeviceDesiredStaus_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatistic_after_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatistic_after_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_changed1` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_del` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_instert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devstatus_before_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatusExt_after_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatusExt_after_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatusExt_after_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_delete_player` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_insert_player` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_update_player` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_TaskTemplate_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_play_Schedule_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_play_Schedule_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Event_before_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`bef_media_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`bef_media_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_after_delete` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_del` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_ins` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_del` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_ins` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_update` $$

USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_delete`
AFTER DELETE ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    delete from SrsServerStatus where id=old.id; 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_insert`
AFTER INSERT ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    insert into SrsServerStatus values(new.id, new.`server`, 0); 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_update`
AFTER UPDATE ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    update SrsServerStatus set `server` = new.`server`, count=0 where id = new.id; 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServerStatus_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServerStatus_before_update`
BEFORE UPDATE ON `nccs`.`SrsServerStatus`
FOR EACH ROW
BEGIN
    if(new.count < 0) then
        set new.count = 0;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Timetable_before_update` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Timetable_befroe_insert` $$
USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_userdev_delete` $$
DELIMITER ;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
