#!/bin/bash

# /usr/sbin/logback.sh  /var/log/supervisor/ /var/log/supervisor/backlog/

function findTime(){
	first_name=$(head -1 $1 )
	if [[ ${first_name:0:4} == "time" ]]; then
		first_name="${first_name:6:10}-${first_name:17:8}"
	else
		first_name=="${first_name:0:10}-${first_name:11:8}"
	fi

	last_name=$(tail -1 $1)
	if [[ ${last_name:0:4} == "time" ]]; then
		last_name="${last_name:6:10}-${last_name:17:8}"
	else
		last_name="${last_name:0:10}-${last_name:11:8}"
	fi
	name="time:${first_name=}-${last_name}"
	name=${name//\//-}
}

if [[ $# -ne 2 ]] || [[ ! -d $1 ]];then
	echo "error using:logback.sh logdir backlogdir "
	exit 1
fi

if [[ ! -d $2 ]]; then
	mkdir $2
fi

pattern="iDsteServers"
pattern2="log."
cd $1
for fileName in $1*; do
	if [[ -f $fileName ]] && [[ $fileName =~ $pattern ]] && [[ ${fileName#*$1} =~ $pattern2 ]]; then
		if [[ $(file -ib $fileName) == "text/plain; charset=utf-8" ]];then
			echo "file check success $fileName"
		else
			echo "file check error $fileName"
			continue
		fi
		findTime $fileName
		tarname="$name-${fileName#*$1}.tar.gz"
		tarname=${tarname//:/-}

		tar -czf $tarname ${fileName#*$1} && mv $tarname $2 && rm $fileName
		dirsize=$(du -b $2/ | awk '{print int($1/1024/1024)}')
		minsize=500
		while (($dirsize >$minsize)); do
			echo ">${minsize}M start rm "
			fileold=$(ls -rt $2/*.gz|head -1) && echo  "rm  ${fileold}" && rm  ${fileold}
			dirsize=$(du -b $2/ | awk '{print int($1/1024/1024)}')
		done
 	fi
done


