#!/bin/sh

exit 0

#校验当前运行的mosquitto支持打开的最大文件数量是否大于5000
mosPid=`ps -e | grep mosquitto | awk '{printf $1}'`
openLimit=`cat /proc/${mosPid}/limits  | grep "open files" | awk '{print $4}'`
if [ $? -eq 0 ]; then
    if [ $openLimit -ge 3000 ]; then
        exit 0
    fi
fi


# mosquitto的版本至少要支持service方式启用的版本，因为要修改一些系统限制
count=`systemctl status mosquitto | grep loaded  | grep service | wc -l`
if [ $count -lt 1 ]; then
    apt-add-repository ppa:mosquitto-dev/mosquitto-ppa -y
    apt-get update
    apt-get install mosquitto -y
fi

mosquittoServicePath=`systemctl status mosquitto | grep loaded  | grep service | awk -F ';' '{print $1}' | awk -F '(' '{print $2}'`
if [ ! -f $mosquittoServicePath ]; then
    # echo "找不到mosquitto的service文件。请手动处理mosquitto的最大文件数限制问题，操作手册参考： https://dokuwiki.idste.org/doku.php?id=public:mosquitto \n"
    # echo "查看的方法是：ps -e | grep mosquito 获取pid，然后cat /proc/pid/limits 文件中的Max open files这一项"
    # echo "修改方法是：重新安装直吹service方式的mosquitto，安装方法如下："
    # echo "\t apt-add-repository ppa:mosquitto-dev/mosquitto-ppa -y\n"
    # echo "\t apt-get update\n"
    # echo "\t apt-get install mosquitto -y\n"
    # echo "安装完成之后，需要通过修改mosquitto 的service文件(默认路径是：/lib/systemd/system/mosquitto.service，可以通过systemctl status mosquitto | grep loaded命令查看具体的位置)\n"
    # echo "然后需要修改/lib/systemd/system/mosquitto.service文件，在[Service]下面增加一行LimitNOFILE = 5000\n"
    # echo "然后再重启加载：systemctl daemon-reload && /etc/init.d/mosquitto restart \n"
    # echo "在查看/proc/mosquittopid/limits文件里面的Max open files是否生效"
    exit 1
fi


count=`grep LimitNOFILE $mosquittoServicePath | wc -l`
if [ $? -eq 0 ]; then
    if [ $count -eq 1 ]; then
        sed -i  "s/LimitNOFILE=.*/LimitNOFILE=5000/" $mosquittoServicePath
    else
        sed -i  "/\[Service\]/a\LimitNOFILE=5000" $mosquittoServicePath
    fi
fi

systemctl daemon-reload
/etc/init.d/mosquitto restart


mosPid=`ps -e | grep mosquitto | awk '{printf $1}'`
openLimit=`cat /proc/${mosPid}/limits  | grep "open files" | awk '{print $4}'`
if [ $openLimit -ge 3000 ]; then
    exit 0
fi

exit -1

